#include <bits/stdc++.h>

using namespace std;

const int N = 2007, INF = 1e9 + 7;
pair <int, int> prv[N][N];
bool vis[N][N];
string last_move[N][N];

void bfs() {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            vis[i][j] = false;
            prv[i][j] = {-1, -1};
        }
    }
    queue<pair<int, int>> q;
    q.push({0, 1});
    vis[0][1] = true;
    while (!q.empty()) {
        auto [s, t] = q.front();
        q.pop();
        if (s + t < N && !vis[t][s + t]) {
            vis[t][s + t] = true;
            prv[t][s + t] = {s, t};
            q.push({t, s + t});
            last_move[t][s + t] = "atan cos ";
        }
        if (s + t < N && !vis[s][s + t]) {
            vis[s][s + t] = true;
            prv[s][s + t] = {s, t};
            q.push({s, s + t});
            last_move[s][s + t] = "atan sin ";
        }
        if (t >= s && !vis[t - s][t]) {
            vis[t - s][t] = true;
            prv[t - s][t] = {s, t};
            q.push({t - s, t});
            last_move[t - s][t] = "acos sin ";
        }
        if (t >= s && !vis[t - s][s]) {
            vis[t - s][s] = true;
            prv[t - s][s] = {s, t};
            q.push({t - s, s});
            last_move[t - s][s] = "acos sin ";
        }
    }
}

signed main() {
    bfs();
    int a, b;
    cin >> a >> b;
    int g = gcd(a, b);
    a /= g;
    b /= g;
    a = a * a;
    b = b * b;
    vector <string> actions;
    while (a != 0 || b != 1) {
        actions.push_back(last_move[a][b]);
        auto [na, nb] = prv[a][b];
        a = na;
        b = nb;
    }
    cout << 2 * actions.size() << "\n";
    reverse(actions.begin(), actions.end());
    for (auto elem : actions) {
        cout << elem;
    }
}
