#include <bits/stdc++.h>

#define int ll
#define pb push_back
#define ft first
#define sc second
#define len(v) int(v.size())

typedef long long ll;

using namespace std;

const int mod = 998244353;

int sum(int a, int b) {
    return ((a + b) % mod);
}

int mult(int a, int b) {
    return ((a * b) % mod);
}

int sub(int a, int b) {
    return ((a - b + mod) % mod);
}

int pw(int x, int st) {
    if (st == 0) {
        return 1;
    }
    if (st % 2 == 0) {
        int y = pw(x, st / 2);
        return mult(y, y);
    } else {
        return mult(pw(x, st - 1), x);
    }
}

int rev(int x) {
    return pw(x, mod - 2);
}

int prob(int olen, int n, int x) {
    return pw(mult(olen, rev(n)), x);
}

vector<int> linerise(vector<int>& q, int n, int s, int k) {
    vector<int> otr;
    int frst;
    for (frst = 0; frst < k; frst++) {
        if (q[frst] == s) {
            break;
        }
    }
    for (int j = frst + 1; j < k; j++) {
        otr.pb(q[j] - q[j - 1]);
    }
    otr.pb((n - q[k - 1]) + q[0]);
    for (int j = 1; j <= frst; j++) {
        otr.pb(q[j] - q[j - 1]);
    }
    reverse(otr.begin(), otr.end());
    return otr;
}

signed main() {
#ifdef PC
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif

    int n, k, s;
    cin >> n >> k >> s;

    vector<int> q(k);
    for (int i = 0; i < k; i++) {
        cin >> q[i];
    }
    auto otr = linerise(q, n, s, k);
    int dp[k + 1][k + 1];
    int fac[k + 1];
    int ofac[k + 1];
    int probs[k + 1][k + 1];
    int c[k + 1][k + 1];
    fac[0] = ofac[0] = 1;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j <= k; j++) {
            probs[i][j] = prob(otr[i], n, j);
        }
    }
    for (int i = 1; i <= k; i++) {
        fac[i] = mult(fac[i - 1], i);
        ofac[i] = rev(ofac[i]);
    }
    for (int i = 0; i <= k; i++) {
        for (int j = 0; j <= k; j++) {
            if (i <= j) {
                c[i][j] = mult(fac[j], rev(mult(fac[i], fac[j - i])));
            }
            dp[i][j] = 0;
        }
    }
    dp[0][0] = 1;
    for (int suf = 0; suf < k; suf++) {
        for (int alr = 0; alr <= k; alr++) {
            int can = suf - alr;
            if (can < 0) {
                break;
            }
            for (int i = 0; i <= can; i++) {
                dp[suf + 1][alr + i] = sum(dp[suf + 1][alr + i],
                                           mult(mult(dp[suf][alr], probs[suf][i]), c[i][alr + i]));
            }
        }
    }

    vector<int> prom(k + 1, 0);
    for (int i = 1; i <= k; i++) {
        prom[i] = sub(1, dp[k][i]);
    }

    int res = 0;
    for (int i = 1; i <= k; i++) {
        res = sum(res, mult(i, sub(prom[i], prom[i - 1])));
    }

    cout << res << endl;
    return 0;
}
