import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Locale;
import java.util.Scanner;
import java.util.StringTokenizer;

public class F2 {
	
	
	public double s(double x) {
		return Math.sin(x);
	}
	
	public double t(double x) {
		return Math.tan(x);
	}
	
	public double f1(double x) {
		ans.add("tan");
		ans.add("sin");
		return Math.sin(Math.tan(x));
	}
	
	public double f2(double x) {
		ans.add("sin");
		ans.add("tan");
		return Math.tan(Math.sin(x));
	}
	
	public double f3(double x) {
		ans.add("atan");
		ans.add("asin");
		return Math.asin(Math.atan(x));
	}
	
	public double f4(double x) {
		ans.add("asin");
		ans.add("atan");
		return Math.atan(Math.asin(x));
	}
	
	public double f5(double x) {
		return f4(f2(x));
	}
	
	public double f6(double x) {
		return f2(f4(x));
	}
	
	public double f7(double x) {
		return f1(f3(x));
	}
	
	public double f8(double x) {
		return f3(f1(x));
	}
	
	public double f9(double x) {
		return f5(f7(x));
	}
	
	public double f10(double x) {
		return f7(f5(x));
	}
	
	public double f11(double x) {
		return f6(f8(x));
	}
	
	public double f12(double x) {
		return f8(f6(x));
	}
	
	public double f13(double x) {
		return f9(f12(x));
	}
	
	public double f14(double x) {
		return f12(f9(x));
	}
	
	public double f15(double x) {
		return f11(f10(x));
	}
	
	public double f16(double x) {
		return f10(f11(x));
	}
	
	public double f17(double x) {
		return f13(f15(x));
	}
	
	public double f18(double x) {
		return f15(f13(x));
	}
	
	public double f19(double x) {
		return f16(f14(x));
	}
	
	public double f20(double x) {
		return f14(f16(x));
	}
	
	ArrayList<String> ans = new ArrayList<>();
	ArrayList<String> ans2 = new ArrayList<>();
	
	public void solve() throws IOException {
//		solve1(0.69);
		double best = 0.9;
		Scanner in = new Scanner(System.in);
		int x = in.nextInt();
		int y = in.nextInt();
		double goal = 1.0 * x / y;
		while (goal > best) {
			ans2.add("tan");
			goal = Math.atan(goal);
		}
		while (goal < best) {
			ans2.add("sin");
			goal = Math.asin(goal);
		}
		solve1(goal);
//		System.out.println("here");
//		System.out.println(ans.size() + " " + ans2.size());
		if (ans.size() + ans2.size() > 1000) {
			throw new RuntimeException();
		}
		System.out.println(ans.size() + ans2.size());
		for (String t : ans) {
			System.out.print(t + " ");
		}
		Collections.reverse(ans2);
		for (String t : ans2) {
			System.out.print(t + " ");
		}
		in.close();
	}

	public void solve1(double goal) {
		ans.add("cos");
		double x = 1;
		int ops = 0;
		double v = Math.abs(x - goal);
		while (true) {
			double v1 = Math.abs(f1(x) - goal);
			double v2 = Math.abs(f3(x) - goal);
			if (v1 < v2) {
				if (v1 < v) {
					v = v1;
					ops += 2;
					x = f1(x);
				} else {
					break;
				}
			} else {
				if (v2 < v) {
					v = v2;
					ops += 2;
					x = f3(x);
				} else {
					break;
				}
			}
		}
		while (true) {
			double v1 = Math.abs(f5(x) - goal);
			double v2 = Math.abs(f7(x) - goal);
			if (v1 < v2) {
				if (v1 < v) {
					v = v1;
					ops += 4;
					x = f5(x);
				} else {
					break;
				}
			} else {
				if (v2 < v) {
					v = v2;
					ops += 4;
					x = f7(x);
				} else {
					break;
				}
			}
		}
//		System.out.println(v + " " + ops);
		while (true) {
			double v1 = Math.abs(f9(x) - goal);
			double v2 = Math.abs(f11(x) - goal);
			if (v1 < v2) {
				if (v1 < v) {
					v = v1;
					ops += 8;
					x = f9(x);
				} else {
					break;
				}
			} else {
				if (v2 < v) {
					v = v2;
					ops += 8;
					x = f11(x);
				} else {
					break;
				}
			}
		}
//		System.out.println(v + " " + ops);
		while (true) {
			double v1 = Math.abs(f13(x) - goal);
			double v2 = Math.abs(f15(x) - goal);
			if (v1 < v2) {
				if (v1 < v) {
					v = v1;
					ops += 16;
					x = f13(x);
				} else {
					break;
				}
			} else {
				if (v2 < v) {
					v = v2;
					ops += 16;
					x = f15(x);
				} else {
					break;
				}
			}
		}
//		System.out.println(v + " " + ops);
		while (true) {
			double v1 = Math.abs(f17(x) - goal);
			double v2 = Math.abs(f19(x) - goal);
			if (v1 < v2) {
				if (v1 < v) {
					v = v1;
					ops += 32;
					x = f17(x);
				} else {
					break;
				}
			} else {
				if (v2 < v) {
					v = v2;
					ops += 32;
					x = f19(x);
				} else {
					break;
				}
			}
		}
//		System.out.println(v + " " + ops);
//		System.out.println(ops);
//		System.out.println(Math.abs(goal - x));
//		System.out.println(x + " " + goal);
	}
	
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		try {
			new F2().solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
