#include <bits/stdc++.h>

const int N = 2000100;

using ll = long long;

ll ans = 0;
int a[N];
std::set<int> ladder;
std::set<int> positions[N];

void build(int n) {
	ladder.insert(0);
	int cur = a[0];
	ans += cur;
	for (int i = 1; i < n; ++i) {
		if (a[i] < cur) {
			cur = a[i];
			ladder.insert(i);
		}
		ans += cur;
	}
}

void inc(int pos, int n) {
	auto next = ladder.upper_bound(pos);
	auto prev = std::prev(next);
	int nextIndex = n;
	if (next != ladder.end()) {
		nextIndex = *next;
	}

	positions[a[pos]].erase(pos);
	++a[pos];
	positions[a[pos]].insert(pos);
	if (*prev != pos) {
		return;
	}

	auto it = positions[a[pos] - 1].upper_bound(pos);
	if (it != positions[a[pos] - 1].end() && *it < nextIndex) {
		ans += *it - pos;
		ladder.insert(*it);
	} else {
		ans += nextIndex - pos;
	}

	if (prev != ladder.begin()) {
		auto pr = std::prev(prev);
		if (a[*pr] == a[pos]) {
			ladder.erase(pos);
		}
	}
}

void dec(int pos, int n) {
	auto next = ladder.upper_bound(pos);
	auto prev = std::prev(next);
	int nextIndex = n;
	if (next != ladder.end()) {
		nextIndex = *next;
	}

	positions[a[pos]].erase(pos);
	--a[pos];
	positions[a[pos]].insert(pos);
	if (*prev != pos && a[pos] >= a[*prev]) {
		return;
	}

	ans -= nextIndex - pos;
	ladder.insert(pos);

	if (nextIndex != n && a[pos] == a[nextIndex]) {
		ladder.erase(nextIndex);
	}
}

int main(void) {
	int n;
	scanf("%d", &n);

	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
		positions[a[i]].insert(i);
	}

	build(n);
	printf("%lld\n", ans);

	int q;
	scanf("%d", &q);

	while (q--) {
		int type, v;
		scanf("%d%d", &type, &v);

		if (type == 1) {
			inc(v, n);
		} else {
			dec(v, n);
		}

		printf("%lld\n", ans);
		// for (int i = 0; i < n; ++i) {
		// 	std::cout << a[i] << ' ';
		// }
		// std::cout << std::endl;
		// for (auto i : ladder) {
		// 	std::cout << i << ' ';
		// }
		// std::cout << std::endl;
	}

	return 0;
}