#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const ll MOD = 998244353;

int dd[4][2] = {
        {0, 1},
        {1, 0},
        {0, -1},
        {-1, 0}
};

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<string> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vector<vector<int>> used(n, vector<int>(n));
    vector<int> good(4);
    function<void(int, int)> dfs = [&](int x, int y) {
        used[x][y] = 1;
        for (int o = 0; o < 4; o++) {
            auto [dx, dy] = dd[o];
            int tx = x + dx;
            int ty = y + dy;
            if (tx >= 0 && ty >= 0 && tx < n && ty < n) {
                if (v[tx][ty] == '#') {
                    good[o] = false;
                } else if (v[tx][ty] == '?' && !used[tx][ty]) {
                    dfs(tx, ty);
                }
            }
        }
    };
    ll ans = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (v[i][j] == '?' && !used[i][j]) {
                fill(good.begin(), good.end(), 1);
                dfs(i, j);
                ll cnt = 0;
                for (int o = 0; o < 4; o++) {
                    if (good[o] && good[(o + 1) % 4]) {
                        cnt++;
                    }
                }
                ans = (ans * cnt) % MOD;
            }
        }
    }
    cout << ans;
    return 0;
}
