#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const ll MOD = 998244353;

int dd[4][2] = {
        {0, 1},
        {1, 0},
        {0, -1},
        {-1, 0}
};

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<string> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    ll ans = 1;
    for (int i = 0; i < n; i++) {
        int len = 0;
        int emptyLeft = 1;
        for (int j = 0; j < n; j++) {
            if (v[i][j] == '?') {
                len++;
            } else if (v[i][j] == '#') {
                if (!emptyLeft && len) {
                    ans *= 0;
                }
                emptyLeft = 0;
                len = 0;
            } else if (v[i][j] == '.') {
                if (emptyLeft) {
                    ans = ans * (len + 1) % MOD;
                }
                emptyLeft = 1;
                len = 0;
            }
        }
        if (emptyLeft) {
            ans = ans * (len + 1) % MOD;
        }
    }

    for (int j = 0; j < n; j++) {
        int len = 0;
        int emptyLeft = 1;
        for (int i = 0; i < n; i++) {
            if (v[i][j] == '?') {
                len++;
            } else if (v[i][j] == '#') {
                if (!emptyLeft && len) {
                    ans *= 0;
                }
                emptyLeft = 0;
                len = 0;
            } else if (v[i][j] == '.') {
                if (emptyLeft) {
                    ans = ans * (len + 1) % MOD;
                }
                emptyLeft = 1;
                len = 0;
            }
        }
        if (emptyLeft) {
            ans = ans * (len + 1) % MOD;
        }
    }
    cout << ans;
    return 0;
}
