#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

#define lint int64_t

using namespace std;

const int n = 1075;
int dist[n][n];
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef _LOCAL
    freopen("../input.txt", "r", stdin);
//    freopen(stdout, 'w', "output.txt");
#endif

    lint n, k;
    cin >> n >> k;
    vector<lint> vals(n);
    vector<lint> dists;
    for (int i = 0; i < n; i++) {
        cin >> vals[i];
    }

    lint ans = 0;
    sort(vals.begin(), vals.end());
    for (int i = 0; i < n; i++) {
        if (i < k) {
            dists.push_back(vals[i]);
        } else {
            dists.push_back(vals[i] + dists[i - k]);
        }
        ans += dists[i];
    }

    cout << ans;

    return 0;
}
