#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> field(n);
    for (int i = 0; i < n; i++) {
        cin >> field[i];
    }

    vector<vector<int> > left_idx(n);
    for (int i = 0; i < n; i++) {
        left_idx[i].resize(m);
        int last_idx = -1;
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '#') {
                last_idx = j;
            } else {
                left_idx[i][j] = last_idx;
            }
        }
    }

    vector<vector<int> > right_idx(n);
    for (int i = 0; i < n; i++) {
        right_idx[i].resize(m);
        int last_idx = m;
        for (int j = m - 1; j >= 0; j--) {
            if (field[i][j] == '#') {
                last_idx = j;
            } else {
                right_idx[i][j] = last_idx;
            }
        }
    }

    vector<vector<int> > up_idx(n);
    for (int i = 0; i < n; i++) {
        up_idx[i].resize(m);
    }
    for (int j = 0; j < m; j++) {
        int last_idx = -1;
        for (int i = 0; i < n; i++) {
            if (field[i][j] == '#') {
                last_idx = i;
            } else {
                up_idx[i][j] = last_idx;
            }
        }
    }

    vector<vector<int> > down_idx(n);
    for (int i = 0; i < n; i++) {
        down_idx[i].resize(m);
    }
    for (int j = 0; j < m; j++) {
        int last_idx = n;
        for (int i = n - 1; i >= 0; i--) {
            if (field[i][j] == '#') {
                last_idx = i;
            } else {
                down_idx[i][j] = last_idx;
            }
        }
    }

    int ans = 0;
    int mx1 = 0, mx2 = 0;
    for (int i = 0; i < n; i++) {
        int blocked_j = -1;
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.' && blocked_j < j) {
                int cur = right_idx[i][j] - j;
                if (cur > mx1) {
                    mx2 = mx1;
                    mx1 = cur;
                } else {
                    mx2 = max(mx2, cur);
                }
                blocked_j = right_idx[i][j];
            }
        }
    }
    ans = mx1 + mx2;

    mx1 = 0;
    mx2 = 0;
    for (int j = 0; j < m; j++) {
        int blocked_i = -1;
        for (int i = 0; i < n; i++) {
            if (field[i][j] == '.' && blocked_i < i) {
                int cur = down_idx[i][j] - i;
                if (cur > mx1) {
                    mx2 = mx1;
                    mx1 = cur;
                } else {
                    mx2 = max(mx2, cur);
                }
                blocked_i = down_idx[i][j];
            }
        }
    }
    ans = max(ans, mx1 + mx2);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.') {
                int cur = (right_idx[i][j] - left_idx[i][j] - 1) + (i - up_idx[i][j] - 1);
                ans = max(ans, cur);
                cur = (right_idx[i][j] - left_idx[i][j] - 1) + (down_idx[i][j] - i - 1);
                ans = max(ans, cur);
                cur = (right_idx[i][j] - j - 1) + (down_idx[i][j] - up_idx[i][j] - 1);
                ans = max(ans, cur);
                cur = (j - left_idx[i][j] - 1) + (down_idx[i][j] - up_idx[i][j] - 1);
                ans = max(ans, cur);
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++) {
        solve();
    }
    return 0;
}
