//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define sz(x) (x).size()
#define add push_back
#define all(x) (x).begin(), (x).end()

const int N = 100;
vector <pair <int, int>> gr[N][N];
queue <pair <int, int>> q;
int d[N][N];
bool used[N][N];

void bfs(int h, int m) {
    memset(d, -1, sizeof(d));
    d[h][m] = 0;
    used[h][m] = 1;
    q.push({h, m});
    while (sz(q)) {
        auto [vh, vm] = q.front(); q.pop();
        for (auto w : gr[vh][vm]) {
            if (!used[w.f][w.s]) {
                d[w.f][w.s] = d[vh][vm] + 1;
                used[w.f][w.s] = 1;
                q.push(w);
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    string a, b;
    cin >> a >> b;
    int h1 = (a[0] - '0') * 10 + (a[1] - '0'), m1 = (a[3] - '0') * 10 + (a[4] - '0');
    int h2 = (b[0] - '0') * 10 + (b[1] - '0'), m2 = (b[3] - '0') * 10 + (b[4] - '0');

    for (int h = 0; h < 24; h++) {
        for (int m = 0; m < 60; m++) {
            if (m == 59) {
                gr[h][m].add({(h + 1) % 24, 0});
            } else {
                gr[h][m].add({h, m + 1});
            }
            gr[h][m].add({(h + 1) % 24, m});
        }
    }

    bfs(h1, m1);

    cout << d[h2][m2];
}
