#include <bits/stdc++.h>
#define int long long
using namespace std;

const int mod = 998244353;
const int MAXN = 1010;
string s[MAXN];

int n;

int calc() {
	int ans = 1;
	for(int i = 0; i < n; i++) {
		for(int l = 0; l < n; l++) {
			int r = l;
			while(r < n && s[i][r] == '?')
				++r;
			if(l == r) continue;
			char left = '.', right = '.';
			if(l > 0) left = s[i][l - 1];
			if(r < n) right = s[i][r];
			if(left == '#' && right == '#')
				ans = 0;
			else if(left == '.' && right == '.')
				ans = (ans * (r - l + 1)) % mod;
			l = r - 1;
		}
	}
	return ans;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> s[i];
	int ans = calc();
	for(int i = 0; i < n; i++)
		for(int j = 0; j < i; j++)
			swap(s[i][j], s[j][i]);
	ans = (ans * calc()) % mod;
	cout << ans;
	return 0;
}