#include <bits/stdc++.h>
//#include "ext/pb_ds/assoc_container.hpp"
//#include "ext/pb_ds/tree_policy.hpp"

//using namespace __gnu_pbds;
using namespace std;

typedef long double ld;

#define int long long
#define ALL(x) (x).begin(), (x).end()
//#define ordered_set tree<int, null_type, less, rb_tree_tag, tree_order_statistics_node_update>

int foo(const vector<vector<int>> d) {
    int n = d.size() - 2;
    int m = d[0].size() - 2;

    int ans = 0;

    vector<vector<int>>
            top(n + 2, vector<int> (m + 2, 0)),
            down(n + 2, vector<int> (m + 2, 0)),
            left(n + 2, vector<int> (m + 2, 0)),
            right(n + 2, vector<int> (m + 2, 0));

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (d[i][j] == 1) {
                top[i][j] = top[i - 1][j] + 1;
                left[i][j] = left[i][j - 1] + 1;
            }
        }
    }

    for (int i = n; i >= 1; i--) {
        for (int j = m; j >= 1; j--) {
            if (d[i][j] == 1) {
                down[i][j] = down[i + 1][j] + 1;
                right[i][j] = right[i][j + 1] + 1;
            }
        }
    }

    multiset<int> st, haha;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (d[i][j] == 1) {
                st.insert(down[i][j]);
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (d[i][j] == 1) {
                st.erase(st.find(down[i][j]));
            }
        }
        int mx = (st.size() == 0 ? 0 : *st.rbegin());
        for (int j = 1; j <= m; j++) {
            ans = max(ans, left[i][j] + right[i][j] - 1 + mx);
        }
        for (int j = 1; j <= m; j++) {
            if (d[i][j] == 1) {
                st.insert(top[i][j]);
            }
            if (d[i][j] == 1 && d[i][j + 1] == 0) {
                haha.insert(left[i][j]);
            }
        }
    }

    auto it = haha.rbegin();
    if (haha.size() >= 2) {
        ans = max(ans, *it + *(++it));
    }

    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int T;
    cin >> T;

    while (T--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> d(n + 2, vector<int> (m + 2, 0)),
                            d2(m + 2, vector<int> (n + 2, 0));

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                char c;
                cin >> c;
                d[i][j] = (c == '.' ? 1 : 0);
            }
        }

        for (int i = 1; i <= m; i++) {
            for (int j = 1; j <= n; j++) {
                d2[i][j] = d[j][i];
            }
        }

        cout << max(foo(d), foo(d2)) << '\n';
    }

    return 0;
}