#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ld long double
#define eb emplace_back
#define pb push_back
#define f first
#define s second
#define deb(x) cerr << #x << " = " << x << '\n';

typedef tree <
    pair <int, int>,
    null_type,
    less<pair <int, int>>,
    rb_tree_tag,
    tree_order_statistics_node_update
> ordered_set;

const int inf = 1e9 + 10;
const int INF = 1e18 + 10;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int P1 = 31;
const int P2 = 37;
const ld EPS = 1e-9;
const ld PI = acosl(-1);
const int SOTKA = 100;
const int POLTOS = 50;
const int KASAR = 1000;

const int dx[9] = {1, -1, 0, 0, 1, 1, -1, -1};
const int dy[9] = {0, 0, 1, -1, 1, -1, 1, -1};

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int dp[1001][1001][8];

void solve(){
   int n;
   cin >> n;
   vector <int> a(n);
   for (auto &i: a)
       cin >> i;

   vector <int> b(n);
   for (auto &i: b)
       cin >> i;

   vector <int> pos(n + 1);
   for (int i = 0; i < n; i++){
       pos[a[i]] = i;
   }

   vector <int> ans;

   for (int i = 0; i < n; i++){
       for (int j = pos[b[i]]; j > i; j--){
           if (abs(a[j] - a[j - 1]) >= 2){
               swap(pos[a[j]], pos[a[j - 1]]);
               swap(a[j], a[j - 1]);
               ans.emplace_back(j - 1);
           }
           else{
               cout << -1 << '\n';
               return;
           }
       }
   }

   cout << ans.size() << '\n';
   for (auto &i: ans)
       cout << i + 1 << ' ';
   cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--){
        solve();
    }
    return 0;
}
