#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ld long double
#define eb emplace_back
#define pb push_back
#define f first
#define s second
#define deb(x) cerr << #x << " = " << x << '\n';

typedef tree <
        pair <int, int>,
        null_type,
        less<pair <int, int>>,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int inf = 1e9 + 10;
const int INF = 1e18 + 10;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int P1 = 31;
const int P2 = 37;
const ld EPS = 1e-9;
const ld PI = acosl(-1);
const int SOTKA = 100;
const int POLTOS = 50;
const int KASAR = 1000;
const int mod = 998244353;

const int dx[9] = {1, -1, 0, 0, 1, 1, -1, -1};
const int dy[9] = {0, 0, 1, -1, 1, -1, 1, -1};

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int used[1000100];
int a[1000000];

int t[8000000], c[8000000];

void build(int v, int l, int r){
    if (l == r){
        t[v] = used[l];
    }
    else {
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m + 1, r);
        t[v] = min(t[v * 2 + 1] , t[v * 2 + 2]);
    }
}

void push(int v, int l, int r){
    if (c[v]){
        if (l != r){
            c[v * 2 + 2] += c[v];
            c[v * 2 + 1] += c[v];
        }

        t[v] += c[v];
        c[v] = 0;
    }
}

int get(int v, int l, int r, int tl, int tr){
    push(v, tl, tr);
    if (l > r)
        return INF;
    if (l == tl && tr == r){
        return t[v];
    }
    else {
        int m = (tl + tr) / 2;
        int x = get(v * 2 + 1, l, min(r, m), tl, m);
        int y = get(v * 2 + 2, max(l, m + 1), r, m + 1, tr);
        return min(x, y);
    }
}

void upd(int v, int l, int r, int tl, int tr, int x){
    push(v, tl, tr);
    if (l > r)
        return;
    if (l == tl && tr == r){
        c[v] += x;
        push(v, tl, tr);
        return;
    }
    else {
        int m = (tl + tr) / 2;
        upd(v * 2 + 1, l, min(r, m), tl, m, x);
        upd(v * 2 + 2, max(l, m + 1), r, m + 1, tr, x);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }
}

void solve(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> used[i];
    }
    map<int, int> mp;
    int last = used[0];
    mp[0] = INF;
    int x = INF;
    int ans = 0;
    for (int i = 0; i <= n; i++){
        int cur = min(x, used[i]);
        ans += (x - cur) * i;
        if (x - cur != 0 && i != 0)
            mp[i] = x - cur;
        used[i] -= cur;
        x = cur;
        if (cur == 0)
            break;
    }
    build(0, 0, n - 1);
    int q;
    cin >> q;
    cout << ans << '\n';
    while (q--){
        int com, val;
        cin >> com >> val;
        if (com == 1){
            if (mp.find(val) != mp.end()){
                mp[val]--;
                if (mp[val] == 0){
                    mp.erase(val);
                }
                upd(0, val, val, 0, n - 1, 1);
                ans -= val;
                int l = val, r = n;
                while (l + 1 < r){
                    int m = (l + r) / 2;
                    int cnt = get(0, val, m, 0, n - 1);
                    if (cnt > 0)
                        l = m;
                    else
                        r = m;
                }
                upd(0, val, l, 0, n - 1, -1);
                mp[l + 1]++;
                ans += l + 1;
            }
            else {
                upd(0, val, val, 0, n - 1, 1);
            }
        }
        else {
            if (get(0, val, val, 0, n - 1) != 0){
                upd(0, val, val, 0, n - 1, -1);
            }
            else {
                auto it = mp.upper_bound(val );
                int cur = it->f;
                upd(0, val + 1, cur - 1, 0, n - 1, 1);
                mp[(*it).f]--;
                if (mp[it->f] == 0){
                    mp.erase(it->f);
                }
                ans -= cur;
                ans += val;
                mp[val] += 1;
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int ttt = 1;
    //    cin >> t;

    while (ttt--){
        solve();
    }
    return 0;
}
