#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long
#define vi vector<int>
#define pii pair<int, int>
#define vec vector

vec<pair<int, pii>> count(const vec<string>& a, bool inv, bool ss) {
	vec<pair<int, pii>> v; v.reserve(a.size());
	for (int i = 0; i < a.size(); ++i) {
		int s = 0, l = 0;
		for (int j = 0; j < a[i].size(); ++j) {
			if (a[i][j] == '#') {
				if (l) {
					v.push_back({ l, {i, s} });
					if (inv) swap(v.back().second.first, v.back().second.second);
				}
				l = 0;
				s = j + 1;
			}
			else ++l;
		}
		if (l) {
			v.push_back({ l, {i, s} });
			if (inv) swap(v.back().second.first, v.back().second.second);
		}
	}

	v.push_back({ 0, {0, 0} }); 
	v.push_back({ 0, {0, 0} });

	if (ss) {
		return { *max_element(v.begin(), v.end()) };
	}std::sort(v.rbegin(), v.rend());
	return v;
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vec<string> a(n);
		for (auto& e : a) cin >> e;
		vec<string> b(m, string(n, ' '));
		for (int j = 0; j < n; ++j) {
			for (int i = 0; i < m; ++i)
				b[i][j] = a[j][i];
		}
		auto x = count(a, 0, 0), y = count(b, 1, 0);

		int ans = max(x[0].first + x[1].first, y[0].first + y[1].first);
		for (int j = 0; j < x[0].first; ++j) {
			b[x[0].second.second + j][x[0].second.first] = '#';
		}
		ans = max(ans, x[0].first + count(b, 0, 1).front().first);
		for (int j = 0; j < y[0].first; ++j) {
			a[y[0].second.first + j][y[0].second.second] = '#';
		}
		ans = max(ans, y[0].first + count(a, 0, 1).front().first);
		cout << ans << "\n";
	}
}