#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define cin(a) for (auto &i : a) cin >> i
#define cout(a, x) for (auto &i : a) cout << i << x; cout << '\n'
#define be(a) a.begin(), a.end()
#define pii pair <int, int>
#define pub push_back
#define pob pop_back
#define F first
#define S second

vector<vector<int> > a;

vector<vector<int> > dp1;
vector<vector<int> > dp2;

vector<vector<int> > r1;
vector<vector<int> > c1;

vector<vector<int> > r2;
vector<vector<int> > c2;


int n;
int m;

void solve() {
    cin >> n >> m;
    a.resize(n, vector<int>(m));

    r1.resize(n, vector<int>(m));
    c1.resize(n, vector<int>(m));

    r2.resize(n, vector<int>(m));
    c2.resize(n, vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            a[i][j] = '#' == c;
        }
    }
    dp1.resize(n + 1, vector<int>(m + 1));
    dp2.resize(n + 1, vector<int>(m + 1));

    for (int i = 0; i < n; ++i) {
        int cur = a[i][0] == 0;
        r1[i][0] = cur;
        for (int j = 1; j < m; ++j) {
            if (a[i][j] == 1) {
                cur = 0;
            } else {
                cur += 1;
            }
            r1[i][j] = max(r1[i][j - 1], cur);
        }
    }

    for (int j = 0; j < m; ++j) {
        int cur = a[0][j] == 0;
        c1[0][j] = cur;
        for (int i = 1; i < n; ++i) {
            if (a[i][j] == 1) {
                cur = 0;
            } else {
                cur += 1;
            }
            c1[i][j] = max(c1[i - 1][j], cur);
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            dp1[i][j] = max({dp1[i - 1][j], dp1[i][j - 1], r1[i - 1][j - 1], c1[i - 1][j - 1]});
        }
    }
    //cout << dp1[n][m] << '\n';
    /// DPPPP 22222
    for (int i = 0; i < n; ++i) {
        int cur = a[i][m - 1] == 0;
        r2[i][m - 1] = cur;
        for (int j = m - 2; j >= 0; --j) {
            if (a[i][j] == 1) {
                cur = 0;
            } else {
                cur += 1;
            }
            r2[i][j] = max(r2[i][j + 1], cur);
        }
    }

    for (int j = 0; j < m; ++j) {
        int cur = a[n - 1][j] == 0;
        c2[n - 1][j] = cur;
        for (int i = n - 2; i >= 0; --i) {
            if (a[i][j] == 1) {
                cur = 0;
            } else {
                cur += 1;
            }
            c2[i][j] = max(c2[i + 1][j], cur);
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            dp2[i][j] = max({dp2[i + 1][j], dp2[i][j + 1], r2[i][j], c2[i][j]});
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            int x = dp1[i][j];
            int y = dp2[i][0];
            int z = dp2[0][j];
            ans = max(ans, x + y);
            ans = max(ans, x + z);
        }
    }

    cout << ans << '\n';
    //cout << dp2[0][0] << '\n';
    dp1.clear();
    dp2.clear();
    r1.clear();
    c1.clear();
    r2.clear();
    c2.clear();
    a.clear();
}
int main() {
    // freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
}
