#include <bits/stdc++.h>
#define IOS ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#define vc vector
#define vi vector<int>
#define vll vector<long long>
#define forn(i,s,n) for(int i = (s); i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define f first
#define s second
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef long double ld;

const int INF = 2e9;
const ll INFL = 1e18;
const int PI = atan(1) * 4;
const int MXN = 1e6;
const int MOD = 1e9 + 7;



void solve(){
    int n, m;
    vector<vector<int>> g;
    vector<pair<vector<int>, vector<int>>> cols, rows;
    cin >> n >> m;
    g.assign(n, vector<int>(m));
    cols.resize(m);
    rows.resize(n);
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            char c;
            cin >> c;
            if (c == '#') {
                g[i][j] = -1;
            } else {
                g[i][j] = 1;
            }
        }
    }

    int ans = 0;

    int amx1 = -1, amx2 = -1;

    for (int i = 0; i < n; ++i){
        vector<int> mx1 = {-1, -1, -1}, mx2 = {-1, -1, -1};
        int s = 0, cur = 0;
        for (int j = 0; j < m; ++j) {
            if (g[i][j] == 1) {
                if (cur == 0) {
                    s = j;
                }
                cur++;
            } else if (g[i][j] == -1 && cur != 0) {
                if (mx1[0] < cur) {
                    mx2 = mx1;
                    mx1 = {cur, s, j - 1};
                } else if (mx2[0] < cur) {
                    mx2 = {cur, s, j - 1};
                }
                cur = 0;
            }
        }
        if (cur != 0) {
            if (mx1[0] < cur) {
                mx2 = mx1;
                mx1 = {cur, s, m - 1};
            } else if (mx2[0] < cur) {
                mx2 = {cur, s, m - 1};
            }
        }
        if (mx1[0] > amx1) {
            amx2 = amx1;
            amx1 = mx1[0];
        } else if (mx1[0] > amx2) {
            amx2 = mx1[0];
        }
        if (mx2[0] > amx2) {
            amx2 = mx1[0];
        }
        rows[i] = {mx1, mx2};
    }
    ans = max(amx2, 0) + max(amx1, 0);
    amx1 = -1;
    amx2 = -1;
    for (int j = 0; j < m; ++j){
        vector<int> mx1 = {-1, -1, -1}, mx2 = {-1, -1, -1};
        int s = 0, cur = 0;
        for (int i = 0; i < n; ++i){
            if (g[i][j] == 1) {
                if (cur == 0){
                    s = i;
                }
                cur++;
            } else if (g[i][j] == -1 && cur != 0) {
                if (mx1[0] < cur) {
                    mx2 = mx1;
                    mx1 = {cur, s, i - 1};
                }
                else if (mx2[0] < cur) {
                    mx2 = {cur, s, i - 1};
                }
                cur = 0;
            }
        }
        if (cur != 0) {
            if (mx1[0] < cur) {
                mx2 = mx1;
                mx1 = {cur, s, n - 1};
            } else if (mx2[0] < cur) {
                mx2 = {cur, s, n - 1};
            }
        }
        if (mx1[0] > amx1) {
            amx2 = amx1;
            amx1 = mx1[0];
        } else if (mx1[0] > amx2) {
            amx2 = mx1[0];
        }

        if (mx2[0] > amx2) {
            amx2 = mx1[0];
        }
        cols[j] = {mx1, mx2};
    }

    ans = max(ans, max(amx1, 0) + max(amx2, 0));

//    for (int i = 0; i < n; ++i) {
//        cout << rows[i].first << " | " << rows[i].second << "\n";
//    }
//    cout << "\n";
//    for (int i = 0; i < m; ++i) {
//        cout << cols[i].first << " | " << cols[i].second << "\n";
//    }
//    cout << endl;

    for (int i = 0; i < n; ++i) {
        if (rows[i].first[0] == -1) continue;
        for (int j = 0; j < m; ++j) {
            if (cols[j].first[0] == -1) continue;
            if (!(i >= cols[j].first[1] && i <= cols[j].first[2] &&
                j >= rows[i].first[1] && j <= rows[i].first[2])){
                ans = max(ans, max(0, rows[i].first[0]) + max(0, cols[j].first[0]));
            } else {
                int cl1 = i - cols[j].first[1];
                int cl2 = cols[j].first[0] - cl1 - 1;
                int rl1 = j - rows[i].first[1];
                int rl2 = rows[i].first[0] - rl1 - 1;
                assert(cl1 + cl2 == cols[j].first[0] - 1);
                assert(rl1 + rl2 == rows[i].first[0] - 1);
                cl1 = max(cl1, cl2);
                rl1 = max(rl1, rl2);
                ans = max({ans, cl1 + rows[i].first[0], rl1 + cols[j].first[0]});
                if (rows[i].second[0] != -1) {
                    ans = max(ans, cols[j].first[0] + rows[i].second[0]);
                }
                if (cols[j].second[0] != -1) {
                    ans = max(ans, cols[j].second[0] + rows[i].first[0]);
                }
            }
        }
    }
    cout << ans << "\n";
}

int main() {
    IOS;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}

/*
  5
2 2
..
..
4 5
###.#
#....
.##.#
#.#.#
2 1
.
.
2 3
###
#.#
5 4
##.#
..#.
#.#.
....
#.##

  */