#include <iostream>
#include <bits/stdc++.h>

#define endl '\n'
typedef long long ll;

using namespace std;

ll n;
vector <vector <ll>> gr(110);
vector <ll> a(110), b(110), dest(110), pos, top;
vector <bool> used;

bool check_fill() {
    for (ll i = 1; i <= n; i++) {
        if (i > 1) {
            if (pos[i] < pos[i - 1]) {
                if (dest[i] > dest[i - 1])
                    return true;
                if (dest[i] > pos[i]) {
                    if (dest[i] > pos[i - 1])
                        gr[i - 1].push_back(i);
                } else if (dest[i] < pos[i]) {
                    if (dest[i - 1] < pos[i])
                        gr[i].push_back(i - 1);
                }
            }
            if (pos[i] > pos[i - 1]) {
                if (dest[i] < dest[i - 1])
                    return true;
                if (dest[i - 1] > pos[i - 1]) {
                    if (dest[i - 1] > pos[i])
                        gr[i].push_back(i - 1);
                } else if (dest[i] < pos[i]) {
                    if (dest[i] < pos[i - 1])
                        gr[i - 1].push_back(i);
                }
            }
        }
    }
    return false;
}

void dfs(ll v) {
    used[v] = true;
    for (auto to : gr[v]) {
        if (!used[to])
            dfs(to);
    }
    top.push_back(v);
}

void solve() {
    cin >> n;
    a.resize(n);
    b.resize(n);
    dest.resize(n + 1);
    pos.resize(n + 1);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
        dest[b[i]] = i;
    }
    if (check_fill()) {
        cout << -1;
        return;
    }
    used.resize(n + 1);
    for (ll i = 1; i <= n; i++)
        if (!used[i])
            dfs(i);
    reverse(top.begin(), top.end());
    ll k = 0;
    vector <ll> ans;
    while (true) {
        for (int el = 1; el <= n; el++) {
            ll curr = pos[el], to = dest[el];
            while (curr != to) {
                if (curr < to) {
                    if (abs(a[curr] - a[curr + 1]) == 1)
                        break;
                    k++;
                    if (!ans.empty() && ans.back() == curr)
                        ans.pop_back();
                    else ans.push_back(curr);
                    pos[a[curr + 1]]--;
                    pos[a[curr]]++;
                    swap(a[curr], a[curr + 1]);
                    curr++;
                } else if (curr > to) {
                    if (abs(a[curr] - a[curr - 1]) == 1)
                        break;
                    k++;
                    if (!ans.empty() && ans.back() == curr - 1)
                        ans.pop_back();
                    else ans.push_back(curr - 1);
                    pos[a[curr - 1]]++;
                    pos[a[curr]]--;
                    swap(a[curr], a[curr - 1]);
                    curr--;
                }
            }
        }
        bool fl = true;
        for (ll i = 0; i < n; i++)
            if (a[i] != b[i]) {
                fl = false;
                break;
            }
        if (fl)
            break;
    }
    cout << ans.size() << endl;
    for (auto el : ans)
        cout << el + 1 << " ";
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}


