#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<limits>
#include<cmath>
#include<fstream>
#include<iomanip>
#include<ctime>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>

using namespace std;

long long mod = 1e9 + 7;

long long gcd(long long a, long long b) {
	if (a < b){
		swap(a, b);
	}
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

long long bin_pow(long long a, long long b) {
	if (b == 0) {
		return 1;
	}
	if (b == 1) {
		return a % mod;
	}
	if (b % 2 == 0) {
		return (bin_pow((a * a) % mod, b / 2)) % mod;
	}
	return ((a % mod) * bin_pow(a, b - 1)) % mod;
}

vector<int> prefix_fun(string& s) {
	vector<int> p(s.size(), 0);
	for (int i = 1; i < s.size(); ++i) {
		int j = p[i - 1];
		while (j > 0 && s[j] != s[i]) j = p[j];
		if (s[i] == s[j]) ++j;
		p[i] = j;
	}
	return move(p);
}

template<typename Type>
class segmentTree{
public:
	segmentTree(const vector<Type>& vec): data(vec.size()*4) {
		for (int i = data.size() - 1; i >= 0; --i) {
		}
	}

	vector<Type> data;
};

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

void solve_b() {
	int n, m;
	cin >> n >> m;
	vector<vector<bool>> mat(n, vector<bool>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char type;
			cin >> type;
			mat[i][j] = 0;
			if (type == '.') mat[i][j] = 1;
		}
	}
	vector<int> dp_left(m, 0);
	vector<int> max_left(n, 0);
	for (int j = 0; j < m; ++j) {
		for (int i = 0; i < n; ++i) {
			if (mat[i][j]) ++max_left[i];
			else max_left[i] = 0;

		}
	}
}

void solve_B() {
	int q;
	cin >> q;
	while (q--) {
		solve_b();
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	//solve_B();

	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	bool e = true;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (abs(a[i] - a[j]) >= 2) {
				continue;
			}
			bool q = true;
			for (int k = 0; k < n; ++k) {
				if (b[k] == a[i]) {
					q = true;
					break;
				}
				else if (b[k] == a[j]) {
					q = false;
					break;
				}
			}
			if (!q) {
				e = false;
				break;
			}
		}
		if (!e) {
			break;
		}
	}
	if (!e) {
		cout << -1;
		return 0;
	}
	vector<int> ans;
	for (int i = 0; i < n; ++i) {
		int j = i;
		for (j; j < n; ++j) {
			if (b[i] == a[j]) {
				break;
			}
		}
		for (j; j > i; --j) {
			ans.emplace_back(j);
			swap(a[j], a[j - 1]);
		}
	}
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i << ' ';
	}
}
