#include <iostream>
#include <vector>
#include <map>
#include <numeric>
#include <algorithm>
#include <deque>
using namespace ::std;
#define ll long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pairInt pair<int, int>
#define pairLL pair<ll, ll>


bool isItPosible = 1;
int n;
vector<int> a, b, ans;

void bubleSort()
{
	int ptr = 0;
	for (int i = 0; i < n; i++)
	{
		int ptrCur = 0;
		for (int j = 0; j < n; j++)
		{
			if (b[ptr] == a[j])
			{
				ptrCur = j;
				break;
			}
		}
		while (ptrCur > ptr)
		{
			if (abs(a[ptrCur] - a[ptrCur - 1]) < 2)
			{
				isItPosible = 0;
				return;
			}
			swap(a[ptrCur], a[ptrCur - 1]);
			ans.push_back(ptrCur);
			ptrCur--;
		}
		ptr++;
	}
}

void doWork()
{
	cin >> n;
	a = vector<int>(n);
	b = vector<int>(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
	}
	bubleSort();
	if (!isItPosible)
	{
		cout << "-1\n";
		return;
	}
	cout << ans.size() << "\n";
	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i] << " ";
	}
	cout << "\n";
}

int main()
{
	int t = 1;
	//cin >> t;
	while (t--)
	{
		doWork();
	}
	return 0;
}