#include <bits/stdc++.h>

using namespace std;

bool is_free(vector<string> &p, int i, int j) {
    if (0 <= i && i < p.size() && 0 <= j && j < p[0].size()) {
        return p[i][j] == '.';
    } else {
        return false;
    }
}

int find_best(vector<string> &p, int &i0, int &j0, int &i1, int &j1) {
    int n = p.size();
    int m = p[0].size();

    int best = 0;
    i0 = j0 = i1 = j1 = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            // gorizontal
            if (!is_free(p, i, j - 1)) {
                int to;
                for (to = j; to < m && p[i][to] == '.'; to++) {}

                if (best < to - j) {
                    best = to - j;
                    i0 = i;
                    j0 = j;
                    i1 = i;
                    j1 = to - 1;
                }
            }

            // vertical
            if (!is_free(p, i - 1, j)) {
                int to;
                for (to = i; to < n && p[to][j] == '.'; to++) {}

                if (best < to - i) {
                    best = to - i;
                    i0 = i;
                    j0 = j;
                    i1 = to - 1;
                    j1 = j;
                }
            }
        }
    }

    return best;
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<string> p(n);
        for (int i = 0; i < n; i++) {
            cin >> p[i];
        }

        int ans = 0;

        int i0, j0, i1, j1;
        ans += find_best(p, i0, j0, i1, j1);

        //cout << "best: " << i0 << ' ' << j0 << ' ' << i1 << ' ' << j1 << endl;

        for (int i = i0; i <= i1; i++) {
            for (int j = j0; j <= j1; j++) {
                p[i][j] = '#';
            }
        }

        for (int i = 0; i < n; i++) {
            //cout << p[i] << endl;
        }

        //cout << endl;

        int loli0, lolj0, loli1, lolj1;
        ans += find_best(p, loli0, lolj0, loli1, lolj1);

        cout << ans << endl;
    }
}
