#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;


vector<int> max_v(vector<vector<int>> g, int n, int m) {
    int a0 = 0, a1 = -1, a2 = -1;
    int b0 = 0, b1 = -1, b2 = -1;
    for(int i = 0; i < n; i++) {
        if (b0 > a0){
            a0 = b0, a1 = b1, a2 = b2;
        }
        b0 = 0, b1 = -1, b2 = -1;
        for(int j = 0; j < m; j++){
            if (g[i][j] == 1){
                if (b0 != 0) {
                    if (b0 > a0){
                        a0 = b0, a1 = b1, a2 = b2;
                    }
                    b0 = 0, b1 = -1, b2 = -1;
                }
            }else{
                if (a0 == 0){
                    a0 = 1, a1 = i, a2 = j;
                    b0 = 1, b1 = i, b2 = j;
                }else{
                    if (b0 == 0){
                        b0 = 1, b1 = i, b2 = j;
                    }else{
                        b0 += 1;
                    }
                }
            }
        }
    }

    if (b0 > a0){
        a0 = b0, a1 = b1, a2 = b2;
    }


    vector<int> aa(3);
    aa[0] = a0;
    aa[1] = a1;
    aa[2] = a2;

    return aa;
}

vector<int> max_g(vector<vector<int> > g, int n, int m) {
    int a0 = 0, a1 = -1, a2 = -1;
    int b0 = 0, b1 = -1, b2 = -1;
    for(int j = 0; j < m; j++) {
        if (b0 > a0){
            a0 = b0, a1 = b1, a2 = b2;
        }
        b0 = 0, b1 = -1, b2 = -1;
        for(int i = 0; i < n; i++){
            if (g[i][j] == 1){
                if (b0 != 0) {
                    if (b0 > a0){
                        a0 = b0, a1 = b1, a2 = b2;
                    }
                    b0 = 0, b1 = -1, b2 = -1;
                }
            }else{
                if (a0 == 0){
                    a0 = 1, a1 = i, a2 = j;
                    b0 = 1, b1 = i, b2 = j;
                }else{
                    if (b0 == 0){
                        b0 = 1, b1 = i, b2 = j;
                    }else{
                        b0 += 1;
                    }
                }
            }
        }
    }

    if (b0 > a0){
        a0 = b0, a1 = b1, a2 = b2;
    }

    vector<int> aa(3);
    aa[0] = a0;
    aa[1] = a1;
    aa[2] = a2;

    return aa;
}

int main() {
    int task;
    cin >> task;
    for (;task > 0; task--) {
        int n, m;
        cin >> n >> m;
        vector< vector<int> > a(n) ;
        string s;
        for(int i = 0; i < n; i++){
            cin >> s;
            //cout << s;
            for(int j = 0; j < m; j++){
                if (s[j] == '#') {
                    a[i].push_back(1);
                }else{
                    a[i].push_back(0);
                }
            }
        }

        //cout<<"test";

        vector<int> mv = max_v(a, n, m);
        vector<int> mg = max_g(a, n, m);

        //cout << mv[0] << mg[0] << endl;

        //cout<<"test";

        for(int i = 0; i < mv[0]; i++){
            a[mv[1]][mv[2] + i] = 1;
        }

        //cout<<"test";

        int mvv = mv[0] + max_v(a, n, m)[0];
        int mvg = mv[0] + max_g(a, n, m)[0];

        //cout<<"test";

        for(int i = 0; i < mv[0]; i++){
            a[mv[1]][mv[2] + i] = 0;
        }

        for(int i = 0; i < mg[0]; i++){
            a[mg[1]+i][mg[2]] = 1;
        }

        int mgv = mg[0] + max_v(a, n, m)[0];
        int mgg = mg[0] + max_g(a, n, m)[0];

        //cout<<"test";

        int M = max(max(mvv, mvg), max(mgv, mgg));
        cout<< M << endl;

//        cout<< mvv << endl;
//        cout<< mvg << endl;
//        cout<< mgv << endl;
//        cout<< mgg << endl;


    }
    return 0;
}

