#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve()
{
    int n,m;
    int answer = 0;
    cin >> n >> m;
    string mp[n];
    for (int i = 0;i < n;i++)
        cin >> mp[i];

    int up[n][m];
    int down[n][m];
    int right[n][m];
    int left[n][m];

    for (int i = 0;i < m;i++)
        up[0][i] = 0;
    for (int j = 1;j < n;j++)
        for (int i = 0;i < m;i++)
        {
            up[j][i] = up[j - 1][i] + 1;
            if (mp[j - 1][i] == '#') up[j][i] = 0;
        }

    for (int i = 0;i < m;i++)
        down[n - 1][i] = 0;
    for (int j = n - 2;j >= 0;j--)
        for (int i = 0;i < m;i++)
        {
            down[j][i] = down[j + 1][i] + 1;
            if (mp[j + 1][i] == '#') down[j][i] = 0;
        }

    for (int i = 0;i < n;i++)
        left[i][0] = 0;
    for (int j = 1;j < m;j++)
        for (int i = 0;i < n;i++)
        {
            left[i][j] = left[i][j - 1] + 1;
            if (mp[i][j - 1] == '#') left[i][j] = 0;
        }

    for (int i = 0;i < n;i++)
        right[i][m - 1] = 0;
    for (int j = m - 2;j >= 0;j--)
        for (int i = 0;i < n;i++)
        {
            right[i][j] = right[i][j + 1] + 1;
            if (mp[i][j + 1] == '#') right[i][j] = 0;
        }

    int y_MAX_gorizont = -1;
    int x_MAX_gorizont = -1;
    int y_MAX_vertikal = -1;
    int x_MAX_vertikal = -1;

    int length_MAX_gorizont = -1;
    int length_MAX_vertikal = -1;

    for (int i = 0;i < n;i++)
    {
        for (int j = 0;j < m;j++)
        {
            if (mp[i][j] != '.') continue;
            if (right[i][j] + 1 <= length_MAX_gorizont) continue;
            length_MAX_gorizont = right[i][j] + 1;
            y_MAX_gorizont = i;
            x_MAX_gorizont = j;
        }
    }

    for (int i = 0;i < n;i++)
    {
        for (int j = 0;j < m;j++)
        {
            if (mp[i][j] != '.') continue;
            if (down[i][j] + 1 <= length_MAX_vertikal) continue;
            length_MAX_vertikal = down[i][j] + 1;
            y_MAX_vertikal = i;
            x_MAX_vertikal = j;
        }
    }

    int y_MAX_gorizont_second = -1;
    int x_MAX_gorizont_second = -1;
    int y_MAX_vertikal_second = -1;
    int x_MAX_vertikal_second = -1;

    int length_MAX_gorizont_second = -1;
    int length_MAX_vertikal_second = -1;

    for (int i = 0;i < n;i++)
    {
        for (int j = 0;j < m;j++)
        {
            if (mp[i][j] != '.') continue;
            if (right[i][j] + 1 <= length_MAX_gorizont_second) continue;
            if (i == y_MAX_gorizont && j >= x_MAX_gorizont && j <= x_MAX_gorizont + length_MAX_gorizont) continue;
            length_MAX_gorizont_second = right[i][j] + 1;
            y_MAX_gorizont_second = i;
            x_MAX_gorizont_second = j;
        }
    }

    for (int i = 0;i < n;i++)
    {
        for (int j = 0;j < m;j++)
        {
            if (mp[i][j] != '.') continue;
            if (down[i][j] + 1 <= length_MAX_vertikal_second) continue;
            if (j == x_MAX_vertikal && i >= y_MAX_vertikal && i <= y_MAX_vertikal + length_MAX_vertikal) continue;
            length_MAX_vertikal_second = down[i][j] + 1;
            y_MAX_vertikal_second = i;
            x_MAX_vertikal_second = j;
        }
    }

    answer = max(answer, length_MAX_vertikal_second + length_MAX_vertikal);
    answer = max(answer, length_MAX_gorizont_second + length_MAX_gorizont);

    for (int i = 0;i < n;i++)
    {
        for (int j = 0;j < m;j++)
        {
            ///i,j
            if (mp[i][j] != '.') continue;
            int sum = up[i][j] + down[i][j] + right[i][j] + left[i][j] + 1;
            sum -= min(min(up[i][j],down[i][j]),min(right[i][j], left[i][j]));
            answer = max(answer, sum);
        }
    }
    ///4th event
    y_MAX_gorizont_second = -1;
    x_MAX_gorizont_second = -1;
    y_MAX_vertikal_second = -1;
    x_MAX_vertikal_second = -1;

    length_MAX_gorizont_second = -1;
    length_MAX_vertikal_second = -1;

    ///second gorizont + MAX_vertikal
    for (int i = 0;i < n;i++)
    {
        for (int j = 0;j < m;j++)
        {
            if (mp[i][j] != '.') continue;
            if (right[i][j] + 1 <= length_MAX_gorizont_second) continue;
            if ((j <= x_MAX_vertikal && x_MAX_vertikal <= j + right[i][j]) && (y_MAX_vertikal <= i && i <= y_MAX_vertikal + length_MAX_vertikal)) continue;
            length_MAX_gorizont_second = right[i][j] + 1;
            y_MAX_gorizont_second = i;
            x_MAX_gorizont_second = j;
        }
    }
    answer = max(answer, length_MAX_vertikal + length_MAX_gorizont_second);
    ///second vertikal + MAX_gorizont
    for (int i = 0;i < n;i++)
    {
        for (int j = 0;j < m;j++)
        {
            if (mp[i][j] != '.') continue;
            if (down[i][j] + 1 <= length_MAX_vertikal_second) continue;
            if ((i <= y_MAX_gorizont && y_MAX_gorizont <= i + down[i][j]) && (x_MAX_gorizont <= j && j <= x_MAX_gorizont + length_MAX_gorizont)) continue;
            length_MAX_vertikal_second = down[i][j] + 1;
            y_MAX_vertikal_second = i;
            x_MAX_vertikal_second = j;
        }
    }
    answer = max(answer, length_MAX_gorizont + length_MAX_vertikal_second);

    cout << answer << endl;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    for (int i = 0;i < t;i++)
        solve();
}
