from dataclasses import dataclass

computerCount, hubs = list(map(int, input().split(' ')))

computers = list(map(int, input().split(' ')))[:computerCount]

@dataclass
class Computer:
    power: int
    connected: int
    to_connected: int
    id: int
    all_connected: int

computers = sorted(computers)

allComputers = []

for i in range(len(computers)):
    allComputers.append(Computer(computers[i], -1, -1, i + 1, 0))

for i in range(hubs):
    allComputers[i].to_connected = 0

def sortFunc(x):
    return x.all_connected

def findMin():
    return sorted(allComputers, key=lambda x: x.all_connected)[0]

def hasNoConnected():
    for i in allComputers:
        if i.to_connected == -1:
            return i

    return False

whileWork = True

while whileWork:

    minimal = hasNoConnected()

    if minimal == False:
        whileWork = False
        break
    else:
        minimalComputer = findMin()
        minimalComputer.connected = minimal.id
        minimal.to_connected = minimalComputer.id
        minimalComputer.all_connected += 1

def getAt(id):
    for i in allComputers:
        if i.id == id:
            return i
    return None

def powerFind(totalPower, computer):
    if computer.to_connected == 0:
        return totalPower + computer.power
    else:
        return powerFind(totalPower + computer.power, getAt(computer.to_connected))

result = 0

for computer in allComputers:
    result += powerFind(0, computer)

print(result)