#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod = 998244353, N = 207;

int dp[N][N];

int mul(int a, int b) {
    return a * b % mod;
}

int fp(int a, int p) {
    int ans = 1, c = a;
    for (int i = 0; (1ll << i) <= p; ++i) {
        if ((p >> i) & 1) {
            ans = mul(ans, c);
        }
        c = mul(c, c);
    }
    return ans;
}

int inv(int a) {
    return fp(a, mod - 2);
}

void add(int &a, int b) {
    a += b;
    while (a >= mod) {
        a -= mod;
    }
}

int iv[N];

int C(int n, int k) {
    int ans = 1;
    for (int i = 0; i < k; ++i) {
        ans = mul(ans, n - i);
        ans = mul(ans, iv[i + 1]);
    }
    return ans;
}

int comb[N][N];
#define app push_back
#define answer(out) {cout << (out) << endl; return 0;}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<string> grid(n);
    for (auto &row: grid) {
        cin >> row;
        row = '.' + row + '.';
    }
    grid.emplace_back(string(n + 2, '.'));
    grid.emplace(grid.begin(), string(n + 2, '.'));
    int ans = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (grid[i][j] == '?') {
                int l = j;
                while (grid[i][j] == '?') j++;
                int r = j;
                if (grid[i][l - 1] == '#' && grid[i][r] == '#') answer(0);
                if (grid[i][l - 1] == '.' && grid[i][r] == '.') ans = mul(ans, r - l + 1);
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (grid[j][i] == '?') {
                int l = j;
                while (grid[j][i] == '?') j++;
                int r = j;
                if (grid[l - 1][i] == '#' && grid[r][i] == '#') answer(0);
                if (grid[l - 1][i] == '.' && grid[r][i] == '.') ans = mul(ans, r - l + 1);
            }
        }
    }
    cout << ans << '\n';
    return 0;
}