#include <bits/stdc++.h>

using namespace std;
#define int long long

void ckmin(int &a, int b) {
    if (b < a) {
        a = b;
    }
}

const int N = 1e6 + 7;
int cnt[N], mn[N << 2], prop[N << 2], sum[N << 2];

void relax_min(int v) {
    sum[v] = sum[v * 2 + 1] + sum[v * 2 + 2];
}

void gap(int v, int l, int r, int x) {
    int len = r - l + 1;
    sum[v] = x * len;
}

void push(int v, int l, int r, int m) {
    if (prop[v] != -1) {
        gap(v * 2 + 1, l, m, prop[v]);
        gap(v * 2 + 2, m + 1, r, prop[v]);
        prop[v] = -1;
    }
}

void setval(int v, int l, int r, int ql, int qr, int x) {
    if (r < ql || qr < l) {
        return;
    }
    if (ql <= l && r <= qr) {
        gap(v, l, r, x);
        return;
    }
    int m = (l + r) / 2;
    push(v, l, r, m);
    setval(v * 2 + 1, l, m, ql, qr, x);
    setval(v * 2 + 2, m + 1, r, ql, qr, x);
    relax_min(v);
}

void build_min(int v, int l, int r) {
    if (l == r) {
        sum[v] = mn[l];
        return;
    }
    int m = (l + r) / 2;
    build_min(v * 2 + 1, l, m);
    build_min(v * 2 + 2, m + 1, r);
    relax_min(v);
}

void relax_cnt(int v) {
    mn[v] = min(mn[v * 2 + 1], mn[v * 2 + 2]);
}

void build_cnt(int v, int l, int r) {
    if (l == r) {
        mn[v] = cnt[l];
        return;
    }
    int m = (l + r) / 2;
    build_cnt(v * 2 + 1, l, m);
    build_cnt(v * 2 + 2, m + 1, r);
    relax_cnt(v);
}

void setcnt(int v, int l, int r, int i, int x) {
    if (l == r) {
        mn[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (i <= m) {
        setcnt(v * 2 + 1, l, m, i, x);
    } else {
        setcnt(v * 2 + 2, m + 1, r, i, x);
    }
    relax_cnt(v);
}

int getmin_cnt(int v, int l, int r, int ql, int qr) {
    if (qr < l || r < ql) {
        return N;
    }
    if (ql <= l && r <= qr) {
        return mn[v];
    }
    int m = (l + r) / 2;
    return min(getmin_cnt(v * 2 + 1, l, m, ql, qr), getmin_cnt(v * 2 + 2, m + 1, r, ql, qr));
}

int leftless(int v, int l, int r, int from, int x) {
    if (mn[v] >= x || r < from) {
        return N;
    }
    if (l == r) {
        return l;
    }
    int m = (l + r) / 2;
    int t = leftless(v * 2 + 1, l, m, from, x);
    if (t != N) {
        return t;
    } else {
        return leftless(v * 2 + 2, m + 1, r, from, x);
    }
}

struct pt {
    int x, y;

    pt operator-(pt p) const { return {x - p.x, y - p.y}; }

    pt operator*(int k) const {
        return {x * k, y * k};
    }

    friend bool line(pt a, pt b, pt c) { return cross(a - b, c - b) == 0; }

    bool on(pt u, pt v) { return scalar(*this - u, v - u) > 0 && scalar(*this - v, u - v) > 0 && line(*this, u, v); }

    friend int scalar(pt v, pt u) { return v.x * u.x + v.y * u.y; }

    friend int cross(pt v, pt u) { return v.x * u.y - v.y * u.x; }

    bool operator<(pt p) const { return pair{x, y} < pair{p.x, p.y}; }
};

const int C = 1e6 + 7;
bool has[10][C];

int getl(int before, int after) {
    int ans = 1e18;
    for (int d = 0; d < 9; ++d) {
        int all = (before & ~(1 << d)) | (after & ~(1 << (d + 1)));
        bool haszero = all & 1;
        int cur = 0;
        for (int i = 1; i < 10; ++i) {
            if (all & (1 << i)) {
                cur = cur * 10 + i;
                if (haszero) cur = cur * 10, haszero = false;
            }
        }
        if (haszero) cur = 10;

        ans = min(ans, cur * 10 + d);
    }
    for (int d = 0; d < 9; ++d) {
        int all = (before & ~(1 << d) & ~(1 << 9)) | (after & ~(1 << (d + 1)) & ~(1 << 0));
        bool haszero = all & 1;
        int cur = 0;
        for (int i = 1; i < 10; ++i) {
            if (all & (1 << i)) {
                cur = cur * 10 + i;
                if (haszero) cur = cur * 10, haszero = false;
            }
        }
        if (haszero) cur = 10;
        ans = min(ans, cur * 100 + d * 10 + 9);
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    string d;
    cin >> d;

    vector<int> pos[10];
    for (int i = 0; i < n; ++i) {
        pos[d[i] - '0'].push_back(i);
    }
    for (int i = 0; i < 10; ++i) {
        //shuffle(pos[i].begin(), pos[i].end());
    }

    int ans = 1e18;

    int k = 0, v = 1;
    while (v < n) {
        v *= 10;
        k++;
    }

    for (int r = 0; r < v; ++r) {
        int before = 0, after = 0;
        for (int c = 0; c < 10; ++c) {
            for (int i: pos[c]) {
                if (r + i < v) {
                    if (!has[c][r + i] && !(c == 0 && (r+i) * 10 < v)) {
                        before ^= 1 << c;
                        break;
                    }
                }
            }
            for (int i: pos[c]) {
                if (r + i >= v) {
                    if (!has[c][r + i - v] && !(c == 0 && (r+i) * 10 < v)) {
                        after ^= 1 << c;
                        break;
                    }
                }
            }
        }
        int l = getl(before, after);
        if (r == 0 && l == 0) l = 1;
        ckmin(ans, l * v + r);
    }

    cout << ans << '\n';
}

int32_t main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    for (int c = 0; c < 10; ++c) {
        for (int n = 0; n < C; ++n) {
            int u = n;
            has[c][n] = (c == n % 10);
            if (n / 10) has[c][n] |= has[c][n / 10];
        }
    }
    int t;
    cin >> t;
    do {
        solve();
    } while (--t);
}
/*
 * 2
5
0 0 0 10
0 5 3 10
0 5 3 0
0 5 7 4
0 5 6 2
8
0 0 10 10
3 4 4 4
4 4 4 5
3 4 4 4
7 7 7 8
7 7 8 7
5 5 4 6
5 5 3 7

 */