#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define x first
#define y second
#define pb push_back
#define mp make_pair

int const maxn = 2e5 + 5;
int cnt[maxn], pref[maxn];
int mn[(1 << 20)];
ll sum[(1 << 20)], psh[(1 << 20)];

inline void push(int i, int l, int r) {
    if (psh[i] != -1) {
        sum[i] = psh[i] * (ll)(r - l);
        psh[2 * i + 1] += psh[i];
        psh[2 * i + 2] += psh[i];
        psh[i] = -1;
    }
}

void upd(int i, int l, int r, int lq, int x) {
    if (r - l == 1) {
        mn[i] = x;
        return;
    }
    int m = (r + l) / 2;
    if (lq < m) upd(2 * i + 1, l, m, lq, x);
    else upd(2 * i + 2, m, r, lq, x);
    mn[i] = min(mn[2 * i + 1], mn[2 * i + 2]);
}

int get(int i, int l, int r, int lq, int rq, int x) {
    if (lq >= r || l >= rq || mn[i] >= x) return rq;
    if (r - l == 1) return l;
    int m = (r + l) / 2;
    int ans = get(2 * i + 1, l, m, lq, rq, x);
    if (ans != rq) return ans;
    return get(2 * i + 2, m, r, lq, rq, x);
}

int get_min(int i, int l, int r, int lq, int rq) {
    if (lq >= r || l >= rq) return maxn;
    if (lq <= l && r <= rq) return mn[i];
    int m = (r + l) / 2;
    return min(get_min(2 * i + 1, l, m, lq, rq), get_min(2 * i + 2, m, r, lq, rq));
}

void upd_sum(int i, int l, int r, int lq, int rq, int x) {
    push(i, l, r);
    if (lq >= r || l >= rq) return;
    if (lq <= l && r <= rq) {
        psh[i] = x;
        push(i, l, r);
        return;
    }
    int m = (r + l) / 2;
    upd_sum(2 * i + 1, l, m, lq, rq, x);
    upd_sum(2 * i + 2, m, r, lq, rq, x);
    sum[i] = sum[2 * i + 1] + sum[2 * i + 2];
}

void build(int i, int l, int r) {
    psh[i] = -1;
    if (r - l == 1) {
        mn[i] = cnt[l];
        sum[i] = pref[l];
    } else {
        int m = (r + l) / 2;
        build(2 * i + 1, l, m);
        build(2 * i + 2, m, r);
        mn[i] = min(mn[2 * i + 1], mn[2 * i + 2]);
        sum[i] = sum[2 * i + 1] + sum[2 * i + 2];
    }
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q, type, value;
    cin >> n;
    for (int i = 0; i < n; i++) cin >> cnt[i];
    pref[0] = cnt[0];
    for (int i = 1; i < n; i++) pref[i] = min(pref[i - 1], cnt[i]);
    build(0, 0, n);
    cin >> q;
    cout << sum[0] << '\n';
    for (int i = 1; i <= q; i++) {
        cin >> type >> value;
        if (type == 1) cnt[value]++;
        else cnt[value]--;
        upd(0, 0, n, value, cnt[value]);
        int V = get_min(0, 0, n, 0, value + 1);
        int pos = get(0, 0, n, value, n, V);
        upd_sum(0, 0, n, value, pos, V);
        cout << sum[0] << '\n';
    }
    return 0;
}

