#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//#define int ll

const int N = 2e5 + 10;
const int SQ = 510;
int calc[N][SQ];

int smart_f(int x, int y) {
    if (y == 0) {
        return x;
    }
    if (x < N && y < SQ) {
        if (calc[x][y] != -1) return calc[x][y];
        else return calc[x][y] = smart_f(y, x / y);
    }
    while (y) {
        x = x / y;
        swap(x, y);
    }
    return x;
}

int stupid_f(int x, int y) {
    while (y) {
        x = x / y;
        swap(x, y);
    }
    return x;
}

signed main() {
#ifdef PC
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    for (int i  = 0; i < N; i++) {
        for (int j = 0; j < SQ; j++) {
            calc[i][j] = -1;
        }
    }
    int n;
    cin >> n;
    int cnt = 0, cnt2 = 0;
    vector<pair<int, int>> kek1, kek2;
    /*for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (i == 1 && j == 1) {
                continue;
            }
            if (stupid_f(i, j) == gcd(i, j)) {
                cnt++;
                kek1.emplace_back(i, j);
            }
        }
    }*/
    for (int y = 2; y <= n; y++) {
        if (y > 1) {
            cnt2++;
            kek2.emplace_back(y, y);
        }
        if (y > 1 && y * 1ll * y <= n) {
            cnt2++;
            kek2.emplace_back(y * y, y);
        }
        for (int k = 1; k <= sqrt(y) + 5; k++) {
            if (y * k > n) {
                break;
            }
            int answ = smart_f(y, k);
            if (y % answ != 0) {
                continue;
            }
            for (int x = y * k; x <= min(y * k + y - 1, n); x += answ) {
                if (gcd(x, y) == answ) {
                    cnt2++;
                    kek2.emplace_back(x, y);
                }
            }
        }
        int mnk = int(sqrt(y)) + 5;
        for (int k = mnk; k < y; k++) {
            if (y * k > n) {
                break;
            }
            int answ = smart_f(y, k);
            if (y % answ != 0) {
                continue;
            }
            for (int x = y * k; x <= min(n, y * k + y - 1); x += answ) {
                if (gcd(x, y) == answ) {
                    cnt2++;
                    kek2.emplace_back(x, y);
                }
            }
        }
    }
    sort(kek2.begin(), kek2.end());
    kek2.resize(unique(kek2.begin(), kek2.end()) - kek2.begin());
    //cout << kek1.size() << ' ' << kek2.size() << '\n';
    /*for (auto [x, y] : kek2) {
        cout << x << ' ' << y << '\n';
    }*/
    /*cout << cnt << '\n';
    for (auto [x, y] : kek1) {
        cout << x << ' ' << y << '\n';
    }
    cout << cnt2 << '\n';
    for (auto [x, y] : kek2) {
        cout << x << ' ' << y << '\n';
    }
    cout << '\n';*/
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int id;
        cin >> id;
        id--;
        if (id >= kek2.size()) {
            cout << "-1 -1" << '\n';
        } else {
            cout << kek2[id].first << ' ' << kek2[id].second << '\n';
        }
    }
}
