#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll MOD = 998244353;

unordered_map<ll, vector<int>> used;
vector<int> steps;
unordered_set<ll> need;

void calc(double cur, int depth) {
    queue<pair<double, int>> q;
    double v = 1;
    q.push({0, 0});
    for (int i = 0; i < 100; i++) {
        q.push({v, 0});
        v = sin(atan(v));
    }
    while (!q.empty()) {
        auto [x, dep] = q.front();
        q.pop();
        auto tr = [&](int val, double nw) {
            for (int z = 0; z < 2; z++) {
                ll l = (ll) (nw * 1e9);
                if (!used.count(l)) {
                    if (need.count(l)) {
                        need.erase(l);
                        cout << l / 1e9 << " " << need.size() << " " << dep << endl;
                    }
                    if (need.count(l + 1)) {
                        need.erase(l + 1);
                        cout << l / 1e9 << " " << need.size() << " " << dep << endl;
                    }
                    if (need.count(l - 1)) {
                        need.erase(l - 1);
                        cout << l / 1e9 << " " << need.size() << " " << dep << endl;
                    }
                    if (z == 0 && abs(nw) < 40) {
                        used[l] = steps;
                        q.push({nw, dep + 1});
                    }
                }
                nw = tan(nw);
            }
        };
        if (dep % 2 == 0) {
            tr(0, sin(x));
            tr(1, cos(x));
        } else {
            if (abs(x) < 1 - 1e-10) {
                tr(3, acos(x));
            }
            if (abs(x) < 1 - 1e-10) {
                tr(4, asin(x));
            }
            tr(5, atan(x));
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    int a, b;
    cin >> a >> b;
    auto solve1 = [&]() {
        vector<string> v;
        v.push_back("cos");
        double u = 1, z = a;
        z /= b;
        while (abs(u - z) > 1e-9) {
            if (u > z) {
                v.push_back("atan");
                v.push_back("sin");
                u = sin(atan(u));
            } else {
                v.push_back("asin");
                u = asin(u);
            }
            if (v.size() > 1000) {
                return vector<string>{};
            }
        }
        return v;
    };

    auto solve2 = [&]() {
        vector<string> v;
        v.push_back("cos");
        double u = 1, z = a;
        z /= b;
        while (abs(tan(acos(u)) - z) > 1e-9) {
            if (tan(acos(u)) < z) {
                v.push_back("atan");
                v.push_back("sin");
                u = sin(atan(u));
            } else {
                v.push_back("asin");
                u = asin(u);
            }
            if (v.size() > 1000) {
                return vector<string>{};
            }
        }
        v.push_back("acos");
        v.push_back("tan");
        return v;
    };

    auto solve3 = [&]() {
        vector<string> v;
        v.push_back("cos");
        double u = 1, z = a;
        z /= b;
        while (abs(tan(u) - z) > 1e-9) {
            if (tan(u) < z) {
                v.push_back("atan");
                v.push_back("sin");
                u = sin(atan(u));
            } else {
                v.push_back("asin");
                u = asin(u);
            }
            if (v.size() > 1000) {
                return vector<string>{};
            }
        }
        v.push_back("tan");
        return v;
    };

    auto ans = max({solve1(), solve2(), solve3()});
    assert(ans.size());
    cout << ans.size() << "\n";
    for (auto &e : ans) {
        cout << e << " ";
    }


    return 0;
}
