#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<cmath>
using namespace std;
#define int long long
const int _1e9 = 1'000'000'000;

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	vector<int> pos1(n), pos2(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a[i]--;
		pos1[a[i]] = i;
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		b[i]--;
		pos2[b[i]] = i;
	}
	for (int i = 0; i + 1 < n; ++i) {
		bool b1 = pos1[i] > pos1[i + 1];
		bool b2 = pos2[i] > pos2[i + 1];
		if (b1 != b2) {
			cout << "-1\n";
			return 0;
		}
	}
	vector<int> res;
	for (int i = 0; i < n; ++i) {
		int p = -1;
		for (int j = 0; j < n; ++j) {
			if (a[j] == b[i]) {
				p = j;
				break;
			}
		}
		while (p > i) {
			res.push_back(p--);
			swap(a[p], a[p + 1]);
		}
	}
	cout << res.size() << '\n';
	for (int x : res) {
		cout << x << ' ';
	}
	cout << '\n';
	return 0;
}