#include <bits/stdc++.h>

using namespace std;

#define int long long

using pi = pair<int, int>;
using db = double;
using vi = vector<int>;
using vvi =  vector<vector<int>>;
using vb = vector<bool>;
using ll = long long;

const int MOD = 1e9 + 7;
const int INF = 1e18 + 1;
const db PI = acos((db)-1);

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).end()
#define rep(n) for (int i = 0; i < n; i++)

mt19937_64 rng('a' + 'n' + 'd' + 'r' + 'e' + 'y' + 'D' + 'a' + 'g' + 'g' + 'e' + 'r');

int binpow(int a, int p, int mod) {
    int res = 1;
    while (p) {
        if (p & 1) a = a * a % mod;
        res = res * a % mod;
        p >>= 1;
    }
    return res;
}

int gcd(int a, int b) {
    a = abs(a), b = abs(b);
    while (a && b) {
        if (a >= b) a %= b;
        else b %= a;
    }
    return max(a, b);
}

int phi(int n) {
    int res = 1;
    for (int d = 2; d * d <= n; d++) {
        if (n % d == 0) {
            int cur = 1;
            while (n % d == 0) {
                n /= d;
                cur *= d;
            }
            res *= cur - cur / d;
        }
    }
    if (n > 1) res *= n - 1;
    return res;
}

void solve() {
    int a1, a2, a3, a4, b; cin >> a1 >> a2 >> a3 >> a4 >> b;
    map<int, int> s;
    s[a1]++;
    s[a2]++;
    s[a3]++;
    s[a4]++;
    if (s.size() == 1) cout << "1\n";
    else {
        if (s.size() >= 3) cout << "0\n";
        else {
            auto first = s.begin();
            s.erase(s.begin());
            auto second = s.begin();
            s.erase(s.begin());
            if (first->second == 1 && first->first + b == second->first) {
                cout << "1\n";
            }
            else {
                cout << "0\n";
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1; // cin >> t
    while (t--) solve();

    return 0;
}
