#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef string str;

#define all(x) x.begin(),x.end()
#define range(i,n) for (int i=0;i<int(n);++i)
#define rrange(i,n) for (int i=(int)(n)-1;i>=0;--i)
#define mp(a,b) make_pair(a,b);
#define md(x,mod) if (x>=mod) x%=mod

template<typename t>istream& operator >>(istream &in, vector<t> &a) {range(i,a.size()) {in >> a[i];}return in;}
template<typename t>ostream& operator <<(ostream &out, vector<t> &a) {range(i,a.size()) {out << a[i] << ' ';}return out;}
template<typename t1,typename t2>istream& operator >>(istream &in, pair<t1,t2> &p) {in >> p.first >> p.second;return in;}
template<typename t1,typename t2>ostream& operator <<(ostream &out, pair<t1,t2> &p) {cout << p.first << ' ' << p.second;return out;}

ll pow(ll x, ll y) {
    ll answer = 1;
    while(y) {
        if (y & 1) {
            answer *= x;
            answer = answer % 998244353;
        }
        x *= x;
        x %= 998244353;
        y >>= 1;
    }
    return answer;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int MOD = 998244353;
    int n;
    cin >> n;
    char c[1000][1000];

    range(i,n) range(j,n) cin >> c[i][j];


    ll answer = 1;
    for (int i = 0; i < n; ++i) {
        ll state1 = 1, state2 = 1;
        ll r1 = 0, r2 = 1, col1 = 0, col2 = 1;
        for (int j = 0; j < n; ++j) {
            if (c[i][j] == '?') {
                r1++;
            } else {
                if (r1 != 0) {
                    state1 += ((c[i][j] == '.') ? 1 : 0);
                    r2 *= (state1 == 0) ? 0 : ((state1 == 1) ? 1 : (r1+1));
                    r2 = r2 % MOD;
                    r1 = 0;
                }
                state1 = (c[i][j] == '.') ? 1 : 0;
            }
            if (c[j][i] == '?') {
                col1++;
            } else {
                if (col1 != 0) {
                    state2 += ((c[j][i] == '.') ? 1 : 0);
                    col2 *= (state2 == 0) ? 0 : ((state2 == 1) ? 1 : (col1+1));
                    col2 = col2 % MOD;
                    col1 = 0;
                }
                state2 = (c[j][i] == '.') ? 1 : 0;
            }
        }
        r2 *= ((state1 == 0) ? 1 : (r1+1));
        r2 = r2 % MOD;
        col2 *= ((state2 == 0) ? 1 : (col1+1));
        col2 = col2 % MOD;
        answer *= r2;
        answer = answer % MOD;
        answer *= col2;
        answer = answer % MOD;
    }
    cout << answer;
}
