#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
typedef long long ll;

using namespace std;

const int N = 1 << 19;
int t[2 * N];

int get_min(int l, int r) {
    int ans = 2e9;
    for (l += N, r += N; l < r; l /= 2, r /= 2) {
        if (l & 1) {
            ans = min(ans, t[l++]);
        }
        if (r & 1) {
            ans = min(ans, t[--r]);
        }
    }
    return ans;
}

void upd(int i, int x) {
    i += N;
    t[i] = x;
    i /= 2;
    while (i > 0) {
        t[i] = min(t[2 * i], t[2 * i + 1]);
        i /= 2;
    }
}

bool check(int i, int j) {
    return get_min(0, i + 1) >= j;
}


inline void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) upd(i, a[i]);

    long long ans = 0;

    vector<long long> pref_min(n + 1);

    pref_min[0] = a[0];

    for (int i = 1; i < n; i++) {
        pref_min[i] = min(pref_min[i - 1], (long long) a[i]);
    }

    long long dif = 0;
    for (int i = n - 1; i >= 0; i--) {
        pref_min[i] -= dif;
        ans += pref_min[i] * (i + 1);
        dif += pref_min[i];
    }

    cout << ans << "\n";

    int q;
    cin >> q;
    while (q--) {
        int type, p;
        cin >> type >> p;
        if (type == 1) {
            int L = -1, R = n;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (check(M, a[p] + 1)) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ans -= R;
            a[p]++;
            upd(p, a[p]);
            L = -1, R = n;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (check(M, a[p])) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ans += R;
        } else {
            int L = -1, R = n;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (check(M, a[p])) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ans -= R;
            a[p]--;
            upd(p, a[p]);
            L = -1, R = n;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (check(M, a[p] + 1)) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ans += R;
        }
        cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
//    cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}