#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
    int n;
    cin >> n;
    vector<int> perm1(n), perm2(n);
    for (int i = 0; i < n; i++) {
        cin >> perm1[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> perm2[i];
    }
    int cur_cnt = 0;
    bool failed = false;
    vector<int> swaps;
    for (int cur_idx = 0; cur_idx < n && !failed && cur_cnt <= 20000; cur_idx++) {
        for (int i = cur_idx; i < n && !failed && cur_cnt <= 20000; i++) {
            if (perm1[i] == perm2[cur_idx]) {
                int idx = i;
                while (idx != cur_idx) {
                    if (abs(perm1[idx] - perm1[idx - 1]) < 2) {
                        failed = true;
                        break;
                    }
                    swap(perm1[idx], perm1[idx - 1]);
                    swaps.push_back(idx);
                    idx--;
                    cur_cnt++;
                }
            }
        }
    }
    if (failed || cur_cnt > 20000) {
        cout << -1;
        return 0;
    }
    cout << cur_cnt << '\n';
    for (int i = 0; i < cur_cnt; i++) {
        cout << swaps[i] << ' ';
    }
    return 0;
}
