#include <bits/stdc++.h>

#define ALL(x) (x).begin(), (x).end()
#define rALL(x) (x).rbegin(), (x).rend()

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 rng(time(0));

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    ll n, k;
    cin >> n >> k;
    vector<int> d(n);
    copy_n(istream_iterator<int>(cin), n, d.begin());
    priority_queue<int, vector<int>, greater<>> q;

    sort(rALL(d));
    ll answer = 0;
    while (!d.empty()) {
        ll tmp = d.back();
        d.pop_back();
        if (q.size() >= k) {
            ll port = q.top();
            q.pop();
            q.push(port + tmp);
            answer += port + tmp;
        } else {
            q.push(tmp);
            answer += tmp;
        }
    }
    cout << answer << endl;

    return 0;
}