#include <bits/stdc++.h>
#ifdef LOCAL
#include "debug.h"
#endif
using namespace std;

#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (auto& x : a) {
        cin >> x;
    }
    vector<int> col(m);
    vector<int> row(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            row[i] += (a[i][j] == '.');
            col[j] += (a[i][j] == '.');
        }
    }
    auto get_mx = [&](const vector<int> ar) {
        int mx1 = 0, mx2 = 0;
        for (auto &x: ar) {
            if (x > mx1) {
                mx2 = mx1;
                mx1 = x;
            } else if (x > mx2) {
                mx2 = x;
            }
        }
        return mx1 + mx2;
    };
    cout << max(get_mx(col), get_mx(row)) << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T = 1;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin >> T;
    for (int t = 0; t < T; ++t) {
        solve();
    }
}
