#include <bits/stdc++.h>
#ifdef LOCAL
#include "debug.h"
#endif
using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), a_pos(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a_pos[--a[i]] = i;
    }

    vector<int> b(n), b_pos(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        b_pos[--b[i]] = i;
    }

    for (int i = 1; i < n; ++i) {
        if ((a_pos[i - 1] < a_pos[i] and b_pos[i - 1] > b_pos[i]) or
            (a_pos[i - 1] > a_pos[i] and b_pos[i - 1] < b_pos[i])) {
            cout << "-1\n";
            return;
        }
    }

    vector<int> result;
    for (int i = 0; i < n - 1; ++i) {
        auto val = b[i];
        auto pos_in_a = a_pos[val];
        for (int j = pos_in_a; j > i; --j) {
            result.push_back(j);
//            cout << "swap a[" << j - 1 << "] and a[" << j << "]" << endl;
            swap(a[j - 1], a[j]);
            swap(a_pos[a[j - 1]], a_pos[a[j]]);
        }
//        cout << endl;
    }

    cout << result.size() << '\n';
    for (auto &i : result) {
        cout << i << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T = 1;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> T;
#endif
    for (int t = 0; t < T; ++t) {
        solve();
    }
}
