#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef string str;
#define int ll
#define $ '\n'
#define forn(i, n) for(int i=0;i<n;++i)
#define max3(_a, _b, _c) (max(max(_a,_b),_c))
#define min3(_a, _b, _c) (min(min(_a,_b),_c))
#define vec vector
#define len(__o) ((int)__o.size())
#define girlfriend friend
#define boyfriend friend

str ALPHA = "abcdefghijklmnopqrstuvwxyz";

typedef vector<int> vi;
typedef vector<int> veci;
typedef set<int> seti;
typedef map<int, int> mapii;
typedef pair<int, int> prii;
typedef vector<veci> graph;

inline const constexpr int md(int a, int m) {
    return ((a + m) % m + m) % m;
}

template<class T>
istream &operator>>(istream &i, vec<T> &a) {
    for (T &e: a) i >> e;
    return i;
}

template<class T>
ostream &operator<<(ostream &o, const vec<T> &a) {
    for (const T &e: a) o << e << ' ';
    return o;
}

const int MOD = 1'000'000'007;

inline void solve();

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}

struct node{
    int val;
    int upd;
};
vector <node> tree;
vector <int> a;

void push(int p, int l, int r) {
    if (l != r) {
        tree[2*p].upd += tree[p].upd;
        tree[2*p+1].upd += tree[p].upd;
    }
    tree[p].val += tree[p].upd;
    tree[p].upd = 0;
}

void build_tree(int p, int l, int r) {
    if (l == r) {
        tree[p].val = a[l];
        return;
    }
    int mid = (l + r) / 2;
    build_tree(2 * p, l, mid);
    build_tree(2 * p + 1, mid + 1, r);
    tree[p].val = min(tree[2 * p].val, tree[2 * p + 1].val);
}

int seg_search(int p, int l, int r, int a) {
    push(p, l, r);
    if (r < a) {
        return 0;
    }
    if (l == r) {
        return min(1LL, tree[p].val);
    }
    int mid = (l + r) / 2;
    if (a <= l) {
        if (tree[p].val == 1) {
            return r - l + 1;
        }
        if (tree[2*p].val >= 1) {
            int w = seg_search(2 * p + 1, mid + 1, r, a);
            return mid - l + 1 + w;
        } else {
            int q = seg_search(2 * p, l, mid, a);
            return q;
        }
    } else {
        if (mid < a) {
            int w = seg_search(2 * p + 1, mid + 1, r, a);
            return w;
        } else {
            int q = seg_search(2 * p, l, mid, a);
            if (q == mid - a + 1) {
                int w = seg_search(2 * p + 1, mid + 1, r, a);
                return q + w;
            } else {
                return q;
            }
        }
    }
}

void minus_tree(int p, int l, int r, int a, int b) {
    push(p, l, r);
    if (r < a || b < l) {
        return;
    }
    if (a <= l && r <= b) {
        tree[p].upd--;
        push(p, l, r);
        return;
    }
    int mid = (l + r) / 2;
    minus_tree(2*p, l, mid, a, b);
    minus_tree(2*p+1, mid+1, r, a, b);
}

void plus_tree(int p, int l, int r, int a, int b) {
    push(p, l, r);
    if (r < a || b < l) {
        return;
    }
    if (a <= l && r <= b) {
        tree[p].upd++;
        push(p, l, r);
        return;
    }
    int mid = (l + r) / 2;
    plus_tree(2*p, l, mid, a, b);
    plus_tree(2*p+1, mid+1, r, a, b);
}

int find_tree(int p, int l, int r, int pos) {
    push(p, l, r);
    if (pos < l || r < pos)
        return 0;
    if (l == r) {
        return min(1LL, tree[p].val);
    }
    int mid = (l + r) / 2;
    int q = find_tree(2 * p, l, mid, pos);
    int w = find_tree(2 * p + 1, mid + 1, r, pos);
    return q + w;
}


inline void solve() {
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    multiset<int> s;
    a.resize(n);
    tree.resize(8 * n);
    forn(i, n)cin >> a[i];
    int q;
    cin >> q;
    vector<pair<int, int> > asks(q);
    forn(i, q) {
        cin >> asks[i].first >> asks[i].second;
    }
    int last = a[0];
    a[0] = 0;
    ll sum = 0;
    for (int i = 1; i < n; i++) {
        if (a[i] < last) {
            for (int j = 0; j < last - a[i]; j++) {
                s.insert(i);
                sum += i;
            }
            last = min(last, a[i]);
        }
        a[i] -= last;
    }
    forn(i, last) {
        s.insert(n);
    }
    build_tree(1, 0, n - 1);
    cout << sum << $;
    forn(_, q) {
        int x, val;
        x = asks[_].first;
        val = asks[_].second;
        if (x == 1) {
            if (val == 0) {
                s.insert(0);
            }
            plus_tree(1, 0, n - 1, val, val);
            auto it = s.find(val);
            if (it == s.end()) {
                cout << sum << $;
                continue;
            }
            int kekw = seg_search(1, 0, n - 1, val);
            minus_tree(1, 0, n-1, val, val + kekw-1);
            sum += kekw;
            s.erase(it);
            s.insert(val+kekw);
            cout << sum << $;
        } else if (x == 2) {
            if (find_tree(1, 0, n-1, val)) {
                minus_tree(1, 0, n-1, val, val);
            }
            else {
                auto it = s.lower_bound(val + 1);
                int aboba = *it;
                sum -= aboba - val;
                if (val != (*it) - 1)
                    plus_tree(1, 0, n-1, val + 1, aboba-1);
                s.erase(it);
                if (val != 0) {
                    s.insert(val);
                }
            }
            cout << sum << $;
        }
    }

}