#include <iostream>
#include <bits/stdc++.h>

#define endl '\n'
typedef long long ll;

using namespace std;

ll n;
vector <vector <ll>> gr(110);
vector <ll> a(110), b(110), dest(110), pos, top;
vector <bool> used;

bool check_fill() {
    for (ll i = 1; i <= n; i++) {
        if (i > 1) {
            if (pos[i] < pos[i - 1]) {
                if (dest[i] > dest[i - 1])
                    return true;
                gr[i - 1].push_back(i);
            }
            if (pos[i] > pos[i - 1]) {
                if (dest[i] < dest[i - 1])
                    return true;
                gr[i].push_back(i - 1);
            }
        }
    }
    return false;
}

void dfs(ll v) {
    used[v] = true;
    for (auto to : gr[v]) {
        if (!used[to])
            dfs(to);
    }
    top.push_back(v);
}

void solve() {
    cin >> n;
    a.resize(n);
    b.resize(n);
    dest.resize(n + 1);
    pos.resize(n + 1);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
        dest[b[i]] = i;
    }
    if (check_fill()) {
        cout << -1;
        return;
    }
    used.resize(n + 1);
    for (ll i = 1; i <= n; i++)
        if (!used[i])
            dfs(i);
    reverse(top.begin(), top.end());
    ll k = 0;
    vector <ll> ans;
    for (auto el : top) {
        ll curr = pos[el], to = dest[el];
        while (curr != to) {
            if (curr < to) {
                k++;
                ans.push_back(curr);
                pos[a[curr + 1]]--;
                pos[a[curr]]++;
                swap(a[curr], a[curr + 1]);
                curr++;
            }
            else {
                k++;
                ans.push_back(curr - 1);
                pos[a[curr - 1]]++;
                pos[a[curr]]--;
                swap(a[curr], a[curr - 1]);
                curr--;
            }
        }
    }
    cout << k << endl;
    for (auto el : ans)
        cout << el + 1 << " ";
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}


