#include <bits/stdc++.h>

using namespace std;

int solve(int n, int m, vector<vector<bool>> table) {
    vector<vector<int>> max_up(n, vector<int>(m, 0));
    vector<vector<int>> max_down(n, vector<int>(m, 0));
    vector<vector<int>> max_left(n, vector<int>(m, 0));
    vector<vector<int>> max_right(n, vector<int>(m, 0));

    int max_v1, max_v2, max_g1, max_g2;

    for (int i = 0; i < n; i++) {
        int cur_max = 0;
        int cur_len = 0;
        for (int j = 0; j < m; j++) {
            if (table[i][j]) {
                cur_len++;
                cur_max = max(cur_max, cur_len);
            } else {
                if (cur_len >= max_g1) {
                    max_g2 = max_g1;
                    max_g1 = cur_len;
                } else if (cur_len > max_g2) {
                    max_g2 = cur_len;
                }
                cur_len = 0;
            }
            max_left[i][j] = cur_max;
        }
        if (cur_len >= max_g1) {
            max_g2 = max_g1;
            max_g1 = cur_len;
        } else if (cur_len > max_g2) {
            max_g2 = cur_len;
        }
    }

    for (int i = 0; i < n; i++) {
        int cur_max = 0;
        int cur_len = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (table[i][j]) {
                cur_len++;
                cur_max = max(cur_max, cur_len);
            } else {
                cur_len = 0;
            }
            max_right[i][j] = cur_max;
        }
    }

    for (int j = 0; j < m; j++) {
        int cur_max = 0;
        int cur_len = 0;
        for (int i = 0; i < n; i++) {
            if (table[i][j]) {
                cur_len++;
                cur_max = max(cur_max, cur_len);
            } else {
                if (cur_len >= max_v1) {
                    max_v2 = max_v1;
                    max_v1 = cur_len;
                } else if (cur_len > max_v2) {
                    max_v2 = cur_len;
                }
                cur_len = 0;
            }
            max_up[i][j] = cur_max;
        }
        if (cur_len >= max_v1) {
            max_v2 = max_v1;
            max_v1 = cur_len;
        } else if (cur_len > max_v2) {
            max_v2 = cur_len;
        }
    }

    for (int j = 0; j < m; j++) {
        int cur_max = 0;
        int cur_len = 0;
        for (int i = n - 1; i >= 0; i--) {
            if (table[i][j]) {
                cur_len++;
                cur_max = max(cur_max, cur_len);
            } else {
                cur_len = 0;
            }
            max_down[i][j] = cur_max;
        }
    }

    int ans = max(max_g1 + max_g2, max_v1 + max_v2);

    vector<int> max_col_left(m, 0);
    vector<int> max_col_right(m, 0);
    max_col_left[0] = max_down[0][0];
    max_col_right[m - 1] = max_down[0][m - 1];
    for (int i = 1; i < m; i++) {
        max_col_left[i] = max(max_col_left[i - 1], max_down[0][i]);
    }
    for (int i = m - 2; i >= 0; i--) {
        max_col_right[i] = max(max_col_right[i + 1], max_down[0][i]);
    }

    for (int i = 0; i < n; i++) {
        int cur_max_up = 0;
        int cur_max_down = 0;
        int max_col = 0;
        for (int j = 0; j < m; j++) {
            if (i != n - 1) {
                cur_max_down = max(cur_max_down, max_down[i + 1][j]);
            }
            if (i != 0) {
                cur_max_up = max(cur_max_up, max_up[i - 1][j]);
            }
            if (j != m - 1) {
                max_col = max_col_right[j + 1];
            }
            int max_v = max(max(cur_max_down, cur_max_up), max_col);

            ans = max(ans, max_v + max_left[i][j]);
            if (ans == 8) {
                cout << i << " " << j << endl;
                cout << cur_max_up << " " << cur_max_down << " " << max_col << endl;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        int cur_max_up = 0;
        int cur_max_down = 0;
        int max_col = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (i != n - 1) {
                cur_max_down = max(cur_max_down, max_down[i + 1][j]);
            }
            if (i != 0) {
                cur_max_up = max(cur_max_up, max_up[i - 1][j]);
            }
            if (j != 0) {
                max_col = max_col_left[j - 1];
            }
            int max_v = max(max(cur_max_down, cur_max_up), max_col);

            ans = max(ans, max_v + max_right[i][j]);
            if (ans == 8) {
                cout << i << " " << j << endl;
            }
        }
    }

//    cout << "=====================" << endl;
//    cout << "max up" << endl;
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            cout << max_up[i][j] << " ";
//        }
//        cout << endl;
//    }
//    cout << "=====================" << endl;
//    cout << "max down" << endl;
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            cout << max_down[i][j] << " ";
//        }
//        cout << endl;
//    }
//    cout << "=====================" << endl;
//    cout << "max left" << endl;
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            cout << max_left[i][j] << " ";
//        }
//        cout << endl;
//    }
//    cout << "=====================" << endl;
//    cout << "max right" << endl;
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            cout << max_right[i][j] << " ";
//        }
//        cout << endl;
//    }
//    cout << "=====================" << endl;
//    cout << max_v1 << " " << max_v2 << " " << max_g1 << " " << max_g2 << endl;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<bool>> table(n, vector<bool>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                char c;
                cin >> c;
                table[i][j] = (c == '.');
            }
        }
        cout << solve(n, m, table) << endl;
    }
    return 0;
}
