#include <bits/stdc++.h>

#define forn(i,n) for(int i=0;i<n;i++)
#define forn1(i,n) for(int i=1;i<n;i++)
#define revforn(i,n) for(int i=n-1;i>=0;i--)
#define revforn1(i,n) for(int i=n-1;i>=1;i--)
#define all(a) a.begin(),a.end()
#define sz(a) (int)a.size()
using namespace std;
using vi = vector<int>;
using vvi = vector<vi>;
using pi = pair<int,int>;
using vpi = vector<pi>;

void printarr(vi &a) {
    for (int &i: a) {
        cout << i << ' ';
    }
    cout << '\n';
}

int solve(vvi& a) {
    int n = sz(a);
    int m = sz(a[0]);

    vvi l(n, vi(m));
    vvi r(n, vi(m));
    vvi mxl(n, vi(m));
    vvi mxr(n, vi(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            l[i][j] = a[i][j];
            mxl[i][j] = a[i][j];
            if (j > 0) {
                l[i][j] += l[i][j - 1];
                if (a[i][j] == 0) {
                    l[i][j] = 0;
                }
                mxl[i][j] = max(l[i][j], mxl[i][j - 1]);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            r[i][j] = a[i][j];
            mxr[i][j] = a[i][j];
            if (j < m - 1) {
                r[i][j] += r[i][j + 1];
                if (a[i][j] == 0) {
                    r[i][j] = 0;
                }
                mxr[i][j] = max(mxr[i][j + 1], r[i][j]);
            }
        }
    }
    int ans = 0;
    vi cols;
    for (int j = 0; j < m; ++j) {
        vi sum(n);
        int mx = 0;
        for (int i = 0; i < n; ++i) {
            sum[i] = a[i][j];
            if (i > 0 && a[i][j]) {
                sum[i] += sum[i - 1];
            }
            mx = max(mx, sum[i]);
        }
        cols.push_back(mx);
        int ll = 0, rr = 0;
        for (int i = 0; i < n; ++i) {
            if (j > 0) {
                ll = max(ll, mxl[i][j - 1]);
            }
            if (j < m - 1) {
                rr = max(rr, mxr[i][j + 1]);
            }
            ans = max(ans, mx + max(ll, rr));
        }
    }
    sort(all(cols));
    if (sz(cols) > 1) {
        ans = max(ans, cols.back() + cols[sz(cols) - 2]);
    }

    return ans;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    while(t--) {
        int n, m;
        cin >> n >> m;
        vvi a(n,vi(m, 0));
        vvi t_a(m,vi(n, 0));
        forn(i,n) {
            forn(j,m) {
                char c;
                cin>>c;
                if (c=='.') a[i][j] = 1;
            }
        }
        forn(i,n) {
            forn(j,m) {
                t_a[j][i] = a[i][j];
            }
        }
        cout<<max(solve(a),solve(t_a))<<'\n';
    }

    return 0;
}