#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<limits>
#include<cmath>
#include<fstream>
#include<iomanip>
#include<ctime>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<tuple>

using namespace std;

long long mod = 998244353;

long long gcd(long long a, long long b) {
	if (a < b){
		swap(a, b);
	}
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

long long bin_pow(long long a, long long b) {
	if (b == 0) {
		return 1;
	}
	if (b == 1) {
		return a % mod;
	}
	if (b % 2 == 0) {
		return (bin_pow((a * a) % mod, b / 2)) % mod;
	}
	return ((a % mod) * bin_pow(a, b - 1)) % mod;
}

vector<int> prefix_fun(string& s) {
	vector<int> p(s.size(), 0);
	for (int i = 1; i < s.size(); ++i) {
		int j = p[i - 1];
		while (j > 0 && s[j] != s[i]) j = p[j];
		if (s[i] == s[j]) ++j;
		p[i] = j;
	}
	return move(p);
}

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

double sith(int depth) {
	if (depth == 0) return 2;
	return tan(sith(depth - 1));
}
/*
int getmax(pair< vector<vector<int>>> vvec, vector<pair<int, int>> >& vec) {
	int i = 0;
	int k = 0;
	while (i < vec.size() && vec[i].first. >= 1)
	{
		++i;
	}
	if (i == vec.size() - 1) {
		--i;
	}

	int j = 0;
	while(j < vec[i].first.size())
}
*/

int main() {
	int n;
	cin >> n;
	vector<vector<char>> mat(n, vector<char>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) cin >> mat[i][j];
	}
	long long ans = 1;
	for (int i = 0; i < n; ++i) {
		int start = -1;
		for (int j = 0; j < n; ++j) {
			if (mat[i][j] == '?') continue;
			char begin = (start == -1) ? '.' : mat[i][start];
			char end = mat[i][j];
			int len = j - start;
			if (begin == '#' && end == '#' && j > start + 1) {
				ans = 0;
			}
			else if (begin == '.' && end == '.') ans = ans * len % mod;
			start = j;
		}
		char begin = (start == -1) ? '.' : mat[i][start];
		char end = '.';
		int len = n - start;
		if (begin == '.' && end == '.') ans = ans * len % mod;
	}
	for (int j = 0; j < n; ++j) {
		int start = -1;
		for (int i = 0; i < n; ++i) {
			if (mat[i][j] == '?') continue;
			char begin = (start == -1) ? '.' : mat[start][j];
			char end = mat[i][j];
			int len = i - start;
			if (begin == '#' && end == '#' && i > start + 1) {
				ans = 0;
			}
			else if (begin == '.' && end == '.') ans = ans * len % mod;
			start = i;
		}
		char begin = (start == -1) ? '.' : mat[start][j];
		char end = '.';
		int len = n - start;
		if (begin == '.' && end == '.') ans = ans * len % mod;
	}
	cout << ans << endl;
}

int man() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	//for (int i = 0; i < 100; ++i) cout << sith(i) << ' ';

	int n;
	cin >> n;
	vector<int> a(n);
	multiset<int> mex;
	for (int i = 0; i < a.size(); ++i)
	{
		cin >> a[i];
	}

	vector<pair<vector<int>, int>> sqrt_vec(sqrt(n) + 1);
	for (auto& i : sqrt_vec) {
		i.first.resize(sqrt(n));
	}
	int k = 0;
	for (auto& i : sqrt_vec) {
		i.second = INT_MAX;
		for (auto& j : i.first) {
			if (k < n)
			{
				j = a[k];
				++k;
			}
			i.second = min(i.second, j);
		}
	}
	return 0;
}
