def get_two(m1, m2, cand):
    if cand[0] > m1[0]:
        return cand, m1
    if cand[0] > m2[0]:
        return m1, cand
    return m1, m2


def get_intersec(vp, vl, gp, gl):
    x, y = (gp[0], vp[1])
    if x < vp[0] or x > vp[0] + vl:
        return False
    if y < gp[1] or y > gp[1] + gl:
        return False
    return x, y


def get_cross_best(g, v, field, n, m):
    if g[0] == 0 or v[0] == 0:
        return g[0] + v[0]
    inters = get_intersec(v[1], v[0], g[1], g[0])
    if not inters:
        return g[0] + v[0]
    sticks = []
    directions = ((0, 1), (1, 0), (0, -1), (-1, 0))
    for direct in directions:
        point = inters
        lng = 0
        while (point[0] < n) and (point[1] < m) and (point[0] >= 0) and (point[1] >= 0) and field[point[0]][
            point[1]] == ".":
            lng += 1
            point = (point[0] + direct[0], point[1] + direct[1])
        sticks.append(lng)
    sticks.sort()
    return sticks[1] + sticks[2] + sticks[3] - 2


def test():
    inp = list(map(int, input().split()))
    n, m = inp[0], inp[1]
    field = list()
    v1 = (0, ())
    v2 = (0, ())
    g1 = (0, ())
    g2 = (0, ())
    cur = 0
    cur_s = -1
    for _ in range(n):
        field.append(input())
    for i in range(n):
        for j in range(m):
            if field[i][j] == '.':
                if cur == 0:
                    cur_s = (i, j)
                cur += 1
            else:
                g1, g2 = get_two(g1, g2, (cur, cur_s))
                cur = 0
        g1, g2 = get_two(g1, g2, (cur, cur_s))
        cur = 0
    for j in range(m):
        for i in range(n):
            if field[i][j] == '.':
                if cur == 0:
                    cur_s = (i, j)
                cur += 1
            else:
                v1, v2 = get_two(v1, v2, (cur, cur_s))
                cur = 0
        v1, v2 = get_two(v1, v2, (cur, cur_s))
        cur = 0

    s1 = v1[0] + v2[0]
    s2 = g1[0] + g2[0]
    s3 = get_cross_best(g1, v1, field, n, m)
    return max(s1, s2, s3)


anss = list()
t = int(input())
for _ in range(t):
    anss.append(test())
for ans in anss:
    print(ans)
