#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define len(s) int(s.size())

int n, m;

struct line{
    int maxl, max_x, max_y;
};

line maxHor(vector<vector<char>>&vec){
    int maxl = 0, max_x, max_y;

    for(int i = 0; i < n; i++){

        int curl = 0;
        int cury = 0;

        for(int j = 0; j < m; j++){
            //cout << "curl: " << i << ' ' << j << ' ' << curl << ' ' << vec[i][j] << '\n';
            if(vec[i][j] == '#'){
                if(curl > maxl){
                    maxl = curl;
                    max_x = i;
                    max_x = cury;
                }
                curl = 0;
            }
            else{
                curl++;
                if(j == 0 || (j > 0 && vec[i][j - 1] == '#')) {
                    cury = j; } //где начинается
            }
        }
        if(curl > maxl){
            maxl = curl;
            max_x = i;
            max_y = cury;
        }
    }
    return {maxl, max_x, max_y};
}

line maxVer(vector<vector<char>>&vec){
    int maxl = 0, max_x, max_y;

    for(int j = 0; j < m; j++){
        int curl = 0;
        int curx = 0;
        for(int i = 0; i < n; i++){
            if(vec[i][j] == '#'){
                if(curl > maxl){
                    maxl = curl;
                    max_y = j;
                    max_x = curx;
                }
                curl = 0;
            }
            else{
                curl++;
                if(i == 0 || (i > 0 && vec[i - 1][j] == '#')) {
                    curx = i;
                    //cout << i << ' ' << j << '\n';
                }  //где начинается
            }
        }
        if(curl > maxl){
            maxl = curl;
            max_y = j;
            max_x = curx;
        }
    }
    return {maxl, max_x, max_y};
}

void solve(){
    cin >> n >> m;
    vector<vector<char>>vec(n, vector<char>(m));
    int cnt_r = 0;

    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cin >> vec[i][j];
            if(vec[i][j] == '.') cnt_r++;
        }
    }

    if(cnt_r <= 1){
        cout << cnt_r << endl;
        return;
    }

    line bestHor1 = maxHor(vec);
    line bestVer1 = maxVer(vec);


    //cout << bestHor1.maxl << ' ' << bestHor1.max_x << ' ' << bestHor1.max_y << endl;
    //cout << bestVer1.maxl << ' ' << bestVer1.max_x << ' ' << bestVer1.max_y << endl;
    //return;

    for(int j = bestHor1.max_y; j < bestHor1.max_y + bestHor1.maxl; j++){
        vec[bestHor1.max_x][j] = '#';
    }

    line bestHor2 = maxHor(vec);
    line bestVer2 = maxVer(vec);

    for(int j = bestHor1.max_y; j < bestHor1.max_y + bestHor1.maxl; j++){
        vec[bestHor1.max_x][j] = '.';
    }

    for(int i = bestVer1.max_x; i < bestVer1.max_x + bestVer1.maxl; i++){
        vec[i][bestVer1.max_y] = '#';
    }

    line bestHor3 = maxHor(vec);
    line bestVer3 = maxVer(vec);

    for(int i = bestVer1.max_x; i < bestVer1.max_x + bestVer1.maxl; i++){
        vec[i][bestVer1.max_y] = '.';
    };

    cout << max({bestHor1.maxl + bestHor2.maxl,
                 bestHor1.maxl + bestVer2.maxl,
                 bestVer1.maxl + bestHor3.maxl,
                 bestVer1.maxl + bestVer3.maxl}) << endl;




}

int32_t main(){
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
   int t;
   cin >> t;
   while(t--){
       solve();
   }
   return 0;
}