#include "bits/stdc++.h"

using namespace std;
#define nn '\n'
typedef long long int ll;
typedef long double ld;

int main() {
    int t; cin >> t;
    for (int _t = 0; _t < t; _t++) {
        int n, m;
        cin >> n >> m;
        vector<int> rs = vector<int>(n);
        vector<int> cs = vector<int>(m);

        vector<int> irs = vector<int>(n);
        vector<int> ics = vector<int>(m);

        vector<int> lrs = vector<int>(n);
        vector<int> lcs = vector<int>(m);

        vector<int> ccols = vector<int>(m);
        for (int i = 0; i < n; i++) {
            string row; cin >> row;
            int crow = 0;
            for (int j = 0; j < m; j++) {
                if (row[j] == '.') {
                    crow++; ccols[j]++;
                    if (ccols[j] > cs[j]) {
                        cs[j] = ccols[j];
                        ics[j] = j;
                        lcs[j] = i;
                    }
                    if (crow > rs[i]) {
                        rs[i] = crow;
                        irs[i] = i;
                        lrs[i] = j;
                    }
                } else {
                    ccols[j] = 0;
                    crow = 0;
                }
            }
        }

        int cfm = 0, cpm = 0;
        int icfm = 0, icpm = 0;
        int lcfm = 0, lcpm = 0;
        for (int i = 0; i < m; i++) {
            if (cs[i] >= cfm) {
                cpm = cfm;
                cfm = cs[i];

                icpm = icfm;
                icfm = ics[i];

                lcpm = lcfm;
                lcfm = lcs[i];
            }

            else if (cs[i] > cpm) {
                cpm = cs[i];
                icpm = ics[i];
                lcpm = lcs[i];
            }
        }

        int rfm = 0, rpm = 0;
        int irfm = 0, irpm = 0;
        int lrfm = 0, lrpm = 0;
        for (int i = 0; i < n; i++) {
            if (rs[i] >= rfm) {
                rpm = rfm;
                rfm = rs[i];

                irpm = irfm;
                irfm = irs[i];

                lrpm = lrfm;
                lrfm = lrs[i];
            } else if (rs[i] > rpm) {
                rpm = rs[i];
                irpm = irs[i];
                lrpm = lrs[i];
            }
        }

        int dds = max(rfm + rpm, cfm + cpm);

        int rfd = max((irfm - (rfm - lrfm)), (cfm - irfm - 1 + (rfm - lrfm)));
        int cfd = max((icfm - (cfm - lcfm)), (rfm - icfm - 1 + (cfm - lcfm)));
        int crfirst = max(rfd + cfm, cfd + rfm);

        if (rfm == cfm and irfm == icfm)
            cout << 1 << nn;
        else
            cout << max(dds, crfirst) << nn;
    }
}

/*
test 1 passed
1
4 5
###.#
#....
.##.#
#.#.#
 */

/*
test 2 passed
1
2 3
###
#.#
 */

/*
test 3
1
5 4
##.#
..#.
#.#.
....
#.##
 */