#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, k = 0;

	cin >> n;
	vector<int> in_cubs(n);
	vector<int> out_cubs(n);
	vector<int> swapped_cubs;
	for(int i = 0; i < n; ++i)
	{
		cin >> in_cubs[i];
	}

	for (int i = 0; i < n; ++i)
	{
		cin >> out_cubs[i];
	}

	for (int i = 0; i < out_cubs.size(); i) 
	{
		auto pos_elem_in = find(in_cubs.begin(), in_cubs.end(), out_cubs[i]);
		int i_elem_in = pos_elem_in - in_cubs.begin();

		if(i_elem_in == i)
		{
			++i;
			continue;
		}

		if(abs(in_cubs[i_elem_in] - in_cubs[i_elem_in-1]) >= 2)
		{
			swap(in_cubs[i_elem_in], in_cubs[i_elem_in - 1]);
			swapped_cubs.push_back(i_elem_in);
			++k;
		}
		else
		{
			cout << -1;
			return 0;
		}
	}

	cout << k << endl;

	if(swapped_cubs.size() > 0)
	{
		cout << swapped_cubs[0];
	}

	for(int i = 1; i < swapped_cubs.size(); ++i)
	{
		cout << " " << swapped_cubs[i];
	}

}