#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long euclid(long x, long y)
{
	//if (x > y)
	//	swap(x, y);

	while (y)
	{
		x %= y;
		//if (y > x)
		return euclid(y, x);
	}
	return x;
}

long task(long x, long y)
{
	while (y > 0)
	{
		x /= y;
		return task(y, x);
	}
	return x;
}

int main()
{
	long n, q;
	vector<pair<long, long>> pi;
	cin >> n >> q;
	for (int i = 2; i <= n; ++i)
	{
		for (int j = 2; j <= i; ++j)
		{
			if (i == j || j * j == i)
			{
				pi.push_back(make_pair(i, j));
				continue;
			}
			if (euclid(i, j) == task(i, j))
			{
				pi.push_back(make_pair(i, j));
			}
		}
	}
	
	for (auto s : pi)
		cout << s.first << " " << s.second << endl;

	for (int i = 0; i < q; ++i)
	{
		cin >> n;
		if (pi.size() >= n)
			cout << pi[n - 1].first << " " << pi[n - 1].second << endl;
		else cout << -1 << " " << -1 << endl;
	}
}