/*
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cstdio>
using namespace std;
#define ll long long
int di[] = { -1,0,1,0 };
int dj[] = { 0,1,0,-1 };
int n;
inline bool good(int i, int j) {
	return i >= 0 && i < n && j >= 0 && j < n;
}
int main(){
	cin >> n;
	vector<string> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<vector<vector<bool>>> blocked(n, vector<vector<bool>>(n,vector<bool>(4)));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (a[i][j] == '#') {
				for (int dir = 0; dir < 4; ++dir) {
					int ni = i + di[dir];
					int nj = j + dj[dir];
					if (good(ni, nj) && a[ni][nj] == '?') {
						if (dir == 0) {
							blocked[ni][nj][0] = true;
							blocked[ni][nj][1] = true;
						}
						else if (dir == 1) {
							blocked[ni][nj][1] = true;
							blocked[ni][nj][2] = true;
						}
						else if (dir == 2) {
							blocked[ni][nj][2] = true;
							blocked[ni][nj][3] = true;
						}
						else {
							blocked[ni][nj][3] = true;
							blocked[ni][nj][0] = true;
						}
					}
				}
			}
		}
	}
	vector<vector<vector<int>>> dp(n, vector<vector<int>>(n, vector<int>(4)));
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (a[i][j] == '?') {
				for (int var = 0; var < 4; ++var) {

						if (var == 0 && (good(i,j+1) && a[i][j + 1] != '#' || !good(i,j+1)) && (good(i + 1, j) && a[i + 1][j] != '#' || !good(i+1,j))) {
							if (good(i-1,j)) {
								dp[i][j][var] += dp[i - 1][j][0] + dp[i - 1][j][1] + dp[i - 1][j][2] + dp[i - 1][j][3];
							}
							if (good(i,j+1)) {
								dp[i][j][var] += dp[i][j + 1][0] + dp[i][j + 1][3];
							}
							if (i < n - 1) {
								dp[i][j][var]+=dp[i+1][j][]
							}
						}
						else if (var == 3 && a[i - 1][j] != '#' && a[i][j + 1] != '#') {

						}

				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (a[i][j] == '?') {
				for (int var = 0; var < 4; ++var) {
					if (var == 1 && var == 2) {
						continue;
					}
					int ni = i + di[var];
					int nj = j + dj[var];

					if (var == 0) {

					}
					else if (var == 1) {

					}
					else if (var == 2) {

					}
					else if (var == 3) {

					}
				}
			}
		}
	}
}
*/



#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cstdio>
using namespace std;

void solve()
{
	int n;
	cin >> n;
	vector <int> a;
	vector <int> c(n);
	vector <int> b;
	int temp;
	for (int i = 0; i < n; ++i)
	{
		cin >> temp;
		a.emplace_back(temp);
		c[temp - 1] = i;
	}
	for (int i = 0; i < n; ++i)
	{
		cin >> temp;
		b.emplace_back(temp);
	}


	vector <int> ans;

	int summ = 0;

	for (int i = 0; i < n; ++i)
	{
		for (int j = c[b[i] - 1] - 1; j >= i; --j)
		{
			if (abs(a[j] - b[i]) > 1 && summ <=20000)
			{
				++summ;
				ans.emplace_back(j);
			}
			else
			{
				cout << -1;
				return;
			}
		}
	}
	cout << ans.size() << endl;
	for (int i : ans)
	{
		cout << i + 1 << ' ';
	}

}
int main()
{
	
	solve();
}
